-- 兑换活动优化
Lua_CashRewardPanel = class("Lua_CashRewardPanel", Lua_DisplayObject);
function Lua_CashRewardPanel:ctor(p)
	self:superCall("ctor", p, "CashRewardPlane_skin");
end

function Lua_CashRewardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.iconSp_1:setEnable(false);
	self.iconSp_2:setEnable(false);
	self.iconNumTxt.text = nil;
	self.leftTimeTxt.text = nil;
	self.textArea = Lua_TextArea.new(self.contentObj, 600, 140);
	self.textArea:setLocation(-16, 631);
	self.textArea:setRectAnchor(7);

	self.rewardList = Lua_DragList.new(self.contentObj, 600, 120, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_CashRewardItem, 120, 120, 1);
	self.rewardList:setLocation(2, 388);
	self.rewardList:setRectAnchor(7);
	self.rewardList:setCellSpacing(10, 0);
	self.cashRewardBtn:addClickFuntion(self,self.gotoCashReward);
	self.addSp:addClickFuntion(self,self.onClickAddSp);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateCostNum);--道具数量增加时更新红点
	self:addLuaEvent("MONEY_UPDATE", self, self.updateCostNum); 

	self:addLuaEvent("UPDATE_CASHREWARD_INFO", self, self.updateServerInfo);
end

-- function Lua_CashRewardPanel:onScreenResize(adaptHeight)
-- 	self:superCall("onScreenResize", adaptHeight);
-- end

function Lua_CashRewardPanel:setData(data)
	self.round = data.param;
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sCashRewardInfo();
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sFirstEnterCashReward(self.round);
end

function Lua_CashRewardPanel:startTimer()
	if self.countDown == nil or self.countDown == false then
		self.countDown = true;
		Lua_CommonUtil.addTimer("updateLeftTime", 1, self, self.updateLeftTime);
	end
end

function Lua_CashRewardPanel:updateLeftTime()
	local residueTime = self.remainTime - DataCenter.roleData.serverTime;
	if residueTime <= 0 then
		self.leftTimeTxt:setLangValue(360000);
		self:endTimer();
		return;
	end
	self.leftTimeTxt.text = LanUtil.formateStr(360001, Lua_TimeTransform.transSeconds16(residueTime, true, true, true, false));
end

function Lua_CashRewardPanel:endTimer()
	if self.countDown ~= nil and self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_CashRewardPanel:updateServerInfo()
	local curRoundInfo = DataCenter.cashRewardData:getRoundConfigDicById(self.round);
	self.actIdx = curRoundInfo.actIdx;

	local txtList = curRoundInfo.des;
	self.str = "";
	for i = 1,#txtList do
		self.str = self.str ..txtList[i][1].."\n";
	end
	self.textArea:setText(self.str, 24, 1.1);

	local mIcon = curRoundInfo.itemCost;
	local moneyTypeCount = DataCenter.packData:getItemCountById(mIcon.id);
	self.iconSp_1:setAltas(mIcon.atlas, mIcon.sprite);
	self.iconSp_2:setAltas(mIcon.atlas, mIcon.sprite);
	self.iconSp_1:setEnable(true);
	self.iconSp_2:setEnable(true);
	self.iconNumTxt.text = moneyTypeCount;

	if curRoundInfo.closeResidueTime ~= nil and curRoundInfo.closeResidueTime > 0 then
		self.remainTime = curRoundInfo.actEndTick;
		self:startTimer();
		self:updateLeftTime();

		local rewards = getConfig({"cash_reward", self.round, "reward_list" });
		if rewards ~= nil then
			local distance = 120 + 10; 
			local recWidth = #rewards <= 4 and #rewards * distance - 10 or distance * 4.5 - 10 * 0.5;
			self.rewardList.canDrag = #rewards > 4;
			self.rewardList:setContentRect(recWidth, 120, false);
			self.rewardList:setArrayData(rewards);
		end
	else
		self:endTimer();
	end

	self:showRedDot(curRoundInfo.hasReward); -- 前往兑换按钮是否显示红点
end

function Lua_CashRewardPanel:updateCostNum(dic)
	if self.round ~= nil then
		local data = DataCenter.cashRewardData:getRoundConfigDicById(self.round);
		local mIcon = data.itemCost;
		if dic ~= nil and dic[mIcon.id] ~= nil then
			self.iconNumTxt.text = DataCenter.packData:getItemCountById(mIcon.id);
		end
	end
end

function Lua_CashRewardPanel:gotoCashReward()
	-- 当兑换活动关闭时
	local actVo = DataCenter.internalActData:getActivityVo(self.actIdx);
	local isClose = DataCenter.internalActData:checkActIsEnd(actVo, "Lua_ExcellentActivityWindow");
	if isClose then
		return;
	end

	Lua_WindowUtil.openWin("Lua_CashShopWindow", Lua_WinParam.ACTION_OPEN, self.round);
end

-- 红点
function Lua_CashRewardPanel:showRedDot(val)
    if val == true then
        if self.redPoint == nil then
            self.redPoint = Lua_RedPointIcon.new(self.cashObj);
            self.redPoint:setLocation(102, 259, 0);
            self.redPoint:setRectAnchor(7);
            self.redPoint:createRedPointEff();
        end
        self.redPoint:updateRedPointShow(true);
    else
        if self.redPoint ~= nil then
            self.redPoint:updateRedPointShow(false);
        end
    end
end

function Lua_CashRewardPanel:onClickAddSp()
	local data = DataCenter.cashRewardData:getRoundConfigDicById(self.round);
	local mIcon = data.itemCost;
	DataCenter.packUtil:openPathWindow(mIcon.id, false);
end

function Lua_CashRewardPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:endTimer();
	self:superCall("dispose");
end










Lua_CashRewardItem = class("Lua_CashRewardItem", Lua_ItemIconCell)
function Lua_CashRewardItem:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon:setScale(0.95, 0.95, 0.95);
end

function Lua_CashRewardItem:setData(data)
	self:superCall("setData", data);
	self.itemIcon:showText(4, nil);
end



