-- 兑换商店
Lua_CashShopWindow = class("Lua_CashShopWindow", Lua_Window)
function Lua_CashShopWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_CashShopWindow";
	self.skinName = "CashShopWindow_skin";
	self.isFullSizeWin = true;
	self.showBackBtn = true;
	self.showWinBg = true;
	self.winBgPath = "/images/cash_reward/xui_dhhd_bg_2.jpg";
end

function Lua_CashShopWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.residueTimeTxt.text = nil;
	self.iconNumTxt.text = nil;
	self.iconSp:setEnable(false);
	self.itemListBg:SetDimensions(699, 973 + self.adaptHeight);
	self.backBtn:setLocation(90, 83);

	self.rewardList = Lua_DragList.new(self.content, 667, 830 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_CashShopRewardCell, 324, 151, 2);
	self.rewardList:setLocation(4, -370);
	self.rewardList:setRectPivot(1)
	self.rewardList:setRectAnchor(1);
	self.rewardList:setCellSpacing(12, 4);
	self.rewardList.tweenId = 2003;
	self:createMoney();
	self.addSp:addClickFuntion(self, self.onClickAddSp);
	self:addLuaEvent("PACK_ITEMS_UPDATE", self, self.updateCostNum);--道具数量增加时更新红点
	self:addLuaEvent("MONEY_UPDATE", self, self.updateCostNum); 
	self:addLuaEvent("UPDATE_CASHREWARD_INFO", self, self.updateServerInfo);
end

function Lua_CashShopWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateServerInfo();
end

function Lua_CashShopWindow:createMoney()
	if self.moneyItem1 == nil then
		local list = {201000001,201000002};
		self.moneyItem1 = Lua_MoneyItem.new(self.content);
		self.moneyItem1:setRectAnchor(1);
		self.moneyItem1:setLocation(249, -26, 0);
		self.moneyItem1:setCanClick(true);
		self.moneyItem1:setMoneyType(list[1]);

		self.moneyItem2 = Lua_MoneyItem.new(self.content);
		self.moneyItem2:setRectAnchor(1);
		self.moneyItem2:setLocation(249 - 190, -26, 0);
		self.moneyItem2:setCanClick(true);
		self.moneyItem2:setMoneyType(list[2]);
	end
end

function Lua_CashShopWindow:onScreenResize()
	self:superCall("onScreenResize");

	self.itemListBg:SetDimensions(699, 973 + self.adaptHeight);
	self.rewardList:setContentRect(675, 840 + self.adaptHeight);
end

function Lua_CashShopWindow:startTimer()
	local residueTime = self.remainTime - DataCenter.roleData.serverTime;
	if residueTime > 0 then
		if self.countDown == nil or self.countDown == false then
			self.countDown = true;
			Lua_CommonUtil.addTimer("updateLeftTime", 1, self, self.updateLeftTime);
		end
	end
end

function Lua_CashShopWindow:updateLeftTime()
	local residueTime = self.remainTime - DataCenter.roleData.serverTime;
	if residueTime <= 0 then
		self.residueTimeTxt:setLangValue(360000); --"兑换剩余：".."00时00分00秒";
		self:endTimer();
		return;
	end
	self.residueTimeTxt.text = LanUtil.formateStr(360001, Lua_TimeTransform.transSeconds16(residueTime, true, true, true, false)) --"兑换剩余："..;
end

function Lua_CashShopWindow:endTimer()
	if self.countDown ~= nil and self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_CashShopWindow:updateServerInfo()
	local data = DataCenter.cashRewardData:getRoundConfigDicById(self.showData);
	local mIcon = data.itemCost;
	local moneyTypeCount = DataCenter.packData:getItemCountById(mIcon.id);
	self.iconSp:setAltas(mIcon.atlas, mIcon.sprite);
	self.iconSp:setEnable(true);
	self.iconNumTxt.text = moneyTypeCount;

	self.remainTime = data.closeTick;
	self:startTimer();
	self:updateLeftTime();

	self.shopItemList = {}; 
	local list = data.rewardArr;
	for i = 1, list:getSize() do
		self.shopItemList[i] = { shopItem = data:getRoundItemById(list[i]), roundId = data.roundId, activityId = data.actIdx };
	end
	self.rewardList:setArrayData(self.shopItemList);
end

function Lua_CashShopWindow:onClickAddSp()
	local data = DataCenter.cashRewardData:getRoundConfigDicById(self.showData);
	local mIcon = data.itemCost;
	DataCenter.packUtil:openPathWindow(mIcon.id, false);
end

function Lua_CashShopWindow:updateCostNum(dic)
	local data = DataCenter.cashRewardData:getRoundConfigDicById(self.showData);
	local mIcon = data.itemCost;
	if dic ~= nil and dic[mIcon.id] ~= nil then
		self.iconNumTxt.text = DataCenter.packData:getItemCountById(mIcon.id);
	end
end

function Lua_CashShopWindow:dispose()
	if self.rewardList ~= nil then 
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.moneyItem1 ~= nil then
		self.moneyItem1:dispose();
		self.moneyItem1 = nil;
	end
	if self.moneyItem2 ~= nil then
		self.moneyItem2:dispose();
		self.moneyItem2 = nil;
	end

	self:endTimer();
	self:superCall("dispose");
end







-------------------------------------------------------
Lua_CashShopRewardCell = class("Lua_CashShopRewardCell", Lua_ListCell);
function Lua_CashShopRewardCell:ctor(p)
    self:superCall("ctor", p, "CashShopItem_skin");
end

function Lua_CashShopRewardCell:buildShowItem()
	self:superCall("buildShowItem");

	self.shopIcon = Lua_ItemIcon.new(self.content);
	self.shopIcon:setScale(0.95, 0.95, 0.95);
	self.shopIcon:setLocation(-83,4);
	self.shopIcon:setSiblingIndex(4);
end

function Lua_CashShopRewardCell:setData(data)
	if data == nil then
		return;
	end
	self.data = data.shopItem;
	self.roundId = data.roundId;
	self.activityId = data.activityId;
	self.tvo = Lua_ToolVo.createToolVo(self.data.rewardItem[1],self.data.rewardItem[2])
	self.shopIcon:setData(self.tvo);
	-- self.shopIcon:setCanClick(self.data.limitTimes > 0);

	local mIcon = DataCenter.cashRewardData:getRoundConfigDicById(self.roundId).itemCost;
	self.iconSp:setAltas(mIcon.atlas, mIcon.sprite);
	-- self.moneyIcon:setData(mIcon);

	local moneyTypeCount = DataCenter.moneyData:getMoney(mIcon.id) ~= 0 and DataCenter.moneyData:getMoney(mIcon.id) or DataCenter.packData:getItemCountById(mIcon.id);
	self.iconPriceTxt.text = moneyTypeCount < self.data.recharge and LanUtil.formateStr(360003, self.data.recharge) or LanUtil.formateStr(360004, self.data.recharge);
	self.limitTimetxt.text = LanUtil.formateStr(360002, self.data.limitTimes);--"库存：";
	-- self.rewardNameTxt.text = self.tvo.name;
	self.recommondSp:setEnable(self.data.recommend == 1);
	self.maskSp:setEnable(self.data.limitTimes <= 0);
	self.sellOutSp:setEnable(self.data.limitTimes <= 0);
	self:setTxtDisplay(self.tvo.name);
end

function Lua_CashShopRewardCell:setTxtDisplay(str)
	self.rewardNameTxt.text = str;
	self.rewardNameTxt:resetSize();
    if self.rewardNameTxt.width > 133 then
        self.rewardNameTxt:setEnable(false);
        if self.scrollText == nil then
            self.scrollText = Lua_ScrollText.new(self.content, Lua_AxisDefine.Horizontal, 133, 24);
            self.scrollText:setLocation(60, 41, 0);
            self.scrollText:setTextStyle(133, 24, Lua_MyUISettings.huakangFontName, 24, "6F5144", 0, "555555");
        end
        self.scrollText:setEnable(true);
        self.scrollText:setShowTxt(str);
    else
        self.rewardNameTxt:setEnable(true);
        if self.scrollText then
            self.scrollText:setEnable(false);
        end
    end
end

function Lua_CashShopRewardCell:onPressClick()
	if self.data == nil or self.data.limitTimes <= 0 then
		return;
	end

	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.shopIcon:checkInBound(winPos.x, winPos.y) then
		DataCenter.packUtil:showItemInfo(self.tvo);
		return;
	end

	local actVo = DataCenter.internalActData:getActivityVo(self.activityId); 
	local isClose = DataCenter.internalActData:checkActIsEnd(actVo, "Lua_ExcellentActivityWindow"); 
	if isClose then		
		Lua_WindowUtil.openWin("Lua_CashShopWindow", Lua_WinParam.ACTION_CLOSE);
		return;
	end

	local mIcon = DataCenter.cashRewardData:getRoundConfigDicById(self.roundId).itemCost;
	local moneyTypeCount = DataCenter.moneyData:getMoney(mIcon.id) ~= 0 and DataCenter.moneyData:getMoney(mIcon.id) or DataCenter.packData:getItemCountById(mIcon.id);
	if moneyTypeCount < self.data.recharge then
		DataCenter.packUtil:openPathWindow(mIcon.id, false);
	else
		local param = {
			id = self.data.rewardItem[1], -- 购买道具id
			itemCount = self.data.rewardItem[2], -- 购买一份商品所携带的数量
			showStyle = 2,
			limitCount = self.data.limitTimes, -- 限购数量，小于0不显示， = 0显示不限购， 默认为1,
			costId = mIcon.id, -- 消耗道具id
			costCount = self.data.recharge, -- 消耗道具数量
			tipStr = "",
			isShowTipWindow = true, -- 点击购买按钮时，是否显示提示窗口
			isShowBackBtn = false, -- 是否显示返回按钮
			cancelBtnStr = LanUtil.getValue(125051), -- 默认取消
			sureBtnStr = LanUtil.getValue(125052), -- 默认确定
			owner = self, 
			callFunc = self.onSureBuy, -- 回调事件
			priceStyle = 1, -- 价格显示类型
			font_size = 26, -- tipWindow文本字体大小
			iconWidth = 46,
			iconHeight = 46
		}; 
		Lua_WindowUtil.openWin("Lua_ShoppingGoodsWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end

function Lua_CashShopRewardCell:onSureBuy(id, selectNum)
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sReceiveCashReward(self.data.id, selectNum, self.roundId);
end

function Lua_CashShopRewardCell:dispose()
	if self.scrollText ~= nil then
		self.scrollText:dispose();
		self.scrollText = nil;
	end
	if self.shopIcon ~= nil then
		self.shopIcon:dispose();
		self.shopIcon = nil;
	end

	self:superCall("dispose");
end
