-- 积天豪礼
Lua_CumulateGiftPanel = class("Lua_CumulateGiftPanel", Lua_DisplayObject);
function Lua_CumulateGiftPanel:ctor(p)
	self:superCall("ctor", p, "CumulateGiftPanel_skin");
end

function Lua_CumulateGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + self.adaptHeight);

	self.title:setLangValue(203500);

	self.giftList = Lua_DragList.new(self.content, 680, 780  + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_CumulateGiftItem, 680, 157, 1);
	self.giftList:setLocation(0, -160, 0);

	self.tipsBtn:addClickFuntion(self, self.onShowTipsClick);

	self:addLuaEvent("UPDATE_CUMULATE_GIFT_INFO", self, self.updateCumulateGiftInfo);
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sCumulateGiftInfo();
end

function Lua_CumulateGiftPanel:setData(data)
end

function Lua_CumulateGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	
	self.bg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + adaptHeight);
	self.giftList:setContentRect(680, 780 + adaptHeight);
end

function Lua_CumulateGiftPanel:updateCumulateGiftInfo()
	local cumulateGiftData = DataCenter.cumulateGiftData;
	local cumulateGiftInfoArr = cumulateGiftData:getCumulateGiftInfoArrBy(cumulateGiftData.curRound);
	self.giftList:setArrayData(cumulateGiftInfoArr);

	self.cumulativeRechargeTxt.text = LanUtil.formateStr(203501, cumulateGiftData._showCumulateGiftInfoDic[cumulateGiftData.index].money);
	local alreadyRecharge;
	if cumulateGiftData.cumulateList[cumulateGiftData.rechargeDays].value >= 1 then
		alreadyRecharge = cumulateGiftData.rechargeDays;
	else
		alreadyRecharge = cumulateGiftData.rechargeDays - 1;
	end
	self.alreadyRechargeTxt.text = LanUtil.formateStr(203502, alreadyRecharge, cumulateGiftData.cumulateGiftConstConfig.show_days);

	self:startTimer();
	self:updateLeftTime();
end

function Lua_CumulateGiftPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_CumulateGiftPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_CumulateGiftPanel:updateLeftTime()
	local remainTime = DataCenter.cumulateGiftData.endTime - DataCenter.roleData.serverTime;
	if remainTime <= 0 then
		remainTime = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(203503, Lua_TimeTransform.transSeconds16(remainTime, true, true, true, false));
end

function Lua_CumulateGiftPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_CumulateGiftPanel:onShowTipsClick(go)
	local tipsData = { des = LanUtil.getValue(203401), posX = 145, posY = 570 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_CumulateGiftPanel:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CumulateGiftItem = class("Lua_CumulateGiftItem", Lua_ListCell);
function Lua_CumulateGiftItem:ctor(p)
    self:superCall("ctor", p, "CumulateGiftItem_skin");
end

function Lua_CumulateGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 345, 100, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_CumulateGiftSubItem, 112, 100, 1);
	self.rewardList:setRectPivot(3);
	self.rewardList:setLocation(-300, -13, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_CumulateGiftItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	
	self.tipsTxt.text = LanUtil.formateStr(203504, data.grade);

	local rewardKey = DataCenter.cumulateGiftData.rewardKey;
	local rewardInfo = getConfig("cumulate_days_recharge", data.id, rewardKey);
	self.rewardList.canDrag = #rewardInfo > 5;
	self.rewardList:setArrayData(rewardInfo);

	local index = DataCenter.cumulateGiftData.index;
	local cumulateList = DataCenter.cumulateGiftData.cumulateList[data.grade];
	self.progressBar.txt.verticalOverflowValue = 1;
	self.progressBar:setMaxValue(self.data.money);
	self.progressBar:setValue(cumulateList.other);
	self.progressBar:setText(cumulateList.other .."/".. self.data.money);

	self.progressBar:setEnable(false);
	self.stateBtn:setStyle(1);
	if cumulateList.value == 0 then
		if self.data.id == index then
			self.stateBtn:setLangValue(203505);
			self.progressBar:setEnable(true);
		else
			self.stateBtn:setLangValue(203506);
			self.stateBtn:setStyle(3);
		end
	elseif cumulateList.value == 1 then
		self.stateBtn:setLangValue(203507);
		self.progressBar:setEnable(true);
	end

	self.stateBtn:setEnable(cumulateList.value ~= 2);
	self.sellOutSp:setEnable(cumulateList.value == 2);
	self:showRedDot(cumulateList.value == 1);
end

function Lua_CumulateGiftItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(307, 103, 0);
			self.redPoint:setRectAnchor(7);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CumulateGiftItem:onBtnClick(go)
	local cumulateList = DataCenter.cumulateGiftData.cumulateList[self.data.grade];
	if cumulateList.value == 0 then
		local index = DataCenter.cumulateGiftData.index;
		if self.data.id == index then
			DataCenter.funcPathUtil:gotoFunction(1024)
		else
			OperateAlert.showLangValue(203508);
		end
	elseif cumulateList.value == 1 then
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sReceiveCumulateGiftGift(self.data.id);
	end
end

function Lua_CumulateGiftItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CumulateGiftSubItem = class("Lua_CumulateGiftSubItem", Lua_ItemIconCell);
function Lua_CumulateGiftSubItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CumulateGiftSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.8, 0.8);
end