-- 每日特惠
Lua_DailyDiscountPanel = class("Lua_DailyDiscountPanel", Lua_DisplayObject);
function Lua_DailyDiscountPanel:ctor(p)
	self:superCall("ctor", p, "DailyDiscountPanel_skin");
end

function Lua_DailyDiscountPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.selectIdx = 1;

	self.btnList = Lua_DragList.new(self.content, 410, 60, Lua_AxisDefine.Horizontal);
	self.btnList:setListCell(Lua_DailyDiscountTypeItem, 162, 60, 1);
	self.btnList:setLocation(130, 249, 0);
	
	self.giftList = Lua_DragList.new(self.content, 675, 550, Lua_AxisDefine.Horizontal);
	self.giftList.tweenId = 2017;
	self.giftList:setListCell(Lua_DailyDiscountItem, 156, 550, 1);
	self.giftList:setRectPivot(3);
	self.giftList:setCellSpacing(17, 0);
	self.giftList:setLocation(-337.5, -80, 0);

	self.buyBtn:addClickFuntion(self, self.onBuyAllGiftClick);

	self:addLuaEvent("DAILYDISCOUNT_TYPE_SELECT", self, self.updateTypeSelectInfo);
	self:addLuaEvent("UPDATE_DAILYDISCOUNT_INFO", self, self.updateTypeShowInfo);
	-- Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sDailyDiscountInfo();
	self:updateTypeShowInfo();
end

function Lua_DailyDiscountPanel:setData(data)
end

function Lua_DailyDiscountPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_DailyDiscountPanel:updateTypeShowInfo()
	local mainGiftList = DataCenter.dailyDiscountData.mainGiftList;
	self.btnList.canDrag = #mainGiftList > 2;
	self.btnList:setArrayData(mainGiftList);
	self.btnList:moveToIndex(self.selectIdx, true, false);
	self.btnList:setSelectClick(self.selectIdx);
	self.btnList:setSelected(self.selectIdx);
	self.btnList:setEnable(#mainGiftList > 1);
end

function Lua_DailyDiscountPanel:updateTypeSelectInfo(data)
	self.selectIdx = data.idx;
	self.rechargeId = data.itemInfo.id;

	local arr = DataCenter.dailyDiscountData:getGiftInfoById(data.itemInfo.id);
	self.giftList.canDrag = arr:getSize() > 4;
	self.giftList:setArrayData(arr);

	self.originalCost.text = LanUtil.formateStr(500000, tostring(data.itemInfo.price));
	self.curCost.text = LanUtil.formateStr(500001, tostring(data.itemInfo.discount_price));
	self.canBuy = arr[1].isCanBuyAll;
	self.buyBtn:setGray(not self.canBuy);
end

function Lua_DailyDiscountPanel:onBuyAllGiftClick()
	if self.canBuy then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.rechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
			tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		OperateAlert.showLangValue(500002);
	end
end

function Lua_DailyDiscountPanel:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_DailyDiscountTypeItem = class("Lua_DailyDiscountTypeItem", Lua_ListCell);
function Lua_DailyDiscountTypeItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_DailyDiscountTypeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.btnIcon = UICreate.createUIAtlasImage(self.content, "", "", 0, 0, 0, 0); 
	self.btnText = UICreate.createLabel(self.content, "", 0, 3, 162, 60, 28);
	self.btnText.fontName = Lua_MyUISettings.huakangFontName;
	self.btnText.alignmentValue = 4;
end

function Lua_DailyDiscountTypeItem:setData(data)
	if data == nil then
		return;
	end

	self.data = getConfig("daily_gift_config", data);
	self.btnText.text = self.data.name;
	self:showRedDot(DataCenter.dailyDiscountData.redShowState[self.data.id]);
end

function Lua_DailyDiscountTypeItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(68, 17, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_DailyDiscountTypeItem:onPressClick()
	if self.data ~= nil then
		Lua_MsgUtil.callFunc("DAILYDISCOUNT_TYPE_SELECT", {idx = self.cellSeqIndex, itemInfo = self.data});
	end
	return true;
end

function Lua_DailyDiscountTypeItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	if bSelect then
		self.btnIcon:setAltas("common_altas_3", "xui_common_toggle_004_f");
		self.btnText.colorStr = Lua_ColorDefine.transColorStr("7E4E2A");
	else
		self.btnIcon:setAltas("common_altas_3", "xui_common_toggle_004_b");
		self.btnText.colorStr = Lua_ColorDefine.transColorStr("836D51");
	end
end

function Lua_DailyDiscountTypeItem:dispose()
	if self.btnIcon ~= nil then
		self.btnIcon:dispose();
		self.btnIcon = nil;
	end
	if self.btnText ~= nil then
		self.btnText:dispose();
		self.btnText = nil;
	end
	self.data = nil;
	
	self:superCall("dispose");
end





--------------------------------------------------





Lua_DailyDiscountItem = class("Lua_DailyDiscountItem", Lua_ListCell);
function Lua_DailyDiscountItem:ctor(p)
	self:superCall("ctor", p, "DailyDiscountItem_skin");
end

function Lua_DailyDiscountItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 106, 344, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_DailyDiscountSubItem, 106, 106, 1);
	self.rewardList:setCellSpacing(0, 13);
	self.rewardList:setRectPivot(1);
	self.rewardList:setLocation(0, 208, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_DailyDiscountItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.rewardList.canDrag = #data.reward > 3;
	self.rewardList:setArrayData(data.reward);

	self.timesTxt.text = LanUtil.formateStr(500003, data.limitTimes);
	self.timesTxt:setEnable(data.limitTimes > 0);

	if data.recharge == 0 then
		self.stateBtn:setLangValue(500004);
	else
		self.stateBtn.label = LanUtil.formateStr(500005, data.recharge);
	end
	self.stateBtn:setEnable(data.limitTimes > 0);
	self.selloutIcon:setEnable(data.limitTimes <= 0);
	self:showRedDot(data.recharge == 0 and data.limitTimes > 0);
end

function Lua_DailyDiscountItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(54, -203, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_DailyDiscountItem:onBtnClick()
	-- print(self.data.id, self.data.recharge, self.data.limitTimes);
	if self.data ~= nil and self.data.limitTimes > 0 then
		if self.data.recharge ~= 0 then
			local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.id);
			DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
					tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
		else
			Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sGetDailyDiscountReward(self.data.id);
		end
	end
end

function Lua_DailyDiscountItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_DailyDiscountSubItem = class("Lua_DailyDiscountSubItem", Lua_ItemIconCell);
function Lua_DailyDiscountSubItem:buildShowItem()
	self:superCall("buildShowItem");
	self.itemIcon:setScale(0.85, 0.85);
end