-- 超值基金和尊享基金
Lua_SpecialFundsPanel = class("Lua_SpecialFundsPanel", Lua_DisplayObject);
function Lua_SpecialFundsPanel:ctor(p)
	self:superCall("ctor", p, "SpecialFundsPanel_skin");
end

function Lua_SpecialFundsPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBg:SetDimensions(711, 726 + self.adaptHeight);

	self.rewardList = Lua_DragList.new(self.content, 665, 690 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.rewardList:setListCell(Lua_SpecialFundsItem, 133, 159, 5);
	self.rewardList:setSiblingIndex(8);
	self.rewardList:setCellSpacing(0, 11);
	self.rewardList:setLocation(0, -70, 0);

	self.rechargeBtn:addClickFuntion(self, self.onSureBtnClick)

	self:addLuaEvent("UPDATE_FUNDSITEM_INFO", self, self.updateFundsItemInfo);
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sSpecialFundsInfo();
end

function Lua_SpecialFundsPanel:setData(data)
	self.selectType = data.param;
	if self.selectType == nil then
		self.selectType = 1;
	end
	DataCenter.fundsData.recordType = self.selectType;
end

function Lua_SpecialFundsPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	self.rewardBg:SetDimensions(711, 726 + adaptHeight);
	self.rewardList:setContentRect(665, 690 + adaptHeight);
end

function Lua_SpecialFundsPanel:updateFundsItemInfo()
	local fundsLvInfo = DataCenter.fundsUtil.fundsLvInfo;
	-- 返利倍数，现在是固定图片艺术字 fundsLvInfo.value[self.selectType][1]
	self.totalValueTxt.text = fundsLvInfo.value[self.selectType][2];
	self.buyStandTxt.text = fundsLvInfo.value[self.selectType][3];

	local fundsData = DataCenter.fundsData;
	local fundsInfoDic = DataCenter.fundsUtil:getFundsInfoByRound(fundsData.round);
	self.rewardList:setArrayData(fundsInfoDic[self.selectType]);
	-- self.rewardList:moveToIndex(fundsData.maxDay[self.selectType], true); -- 策划取消

	local LockMap = fundsData.LockMap[self.selectType];
	self.tipsObj:SetActive(LockMap == 0);

	local rechargeId = fundsLvInfo.grade_list[self.selectType][2];
	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
	if LockMap == 0 then
		self.rechargeBtn.label = LanUtil.formateStr(203000, rechargeInfo.money);
	else
		if fundsData.maxDay[self.selectType] < fundsData.curDay then
			self.rechargeBtn:setGray(false);
			self.rechargeBtn:setLangValue(203001); -- 领取
		else
			self.rechargeBtn:setGray(true);
			self.rechargeBtn:setLangValue(203002); -- 已领取
		end
	end
	self:showRedDot(LockMap ~= 0 and fundsData.maxDay[self.selectType] < fundsData.curDay);
end

function Lua_SpecialFundsPanel:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(108, 254, 0);
			self.redPoint:setRectAnchor(7);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_SpecialFundsPanel:onSureBtnClick(go)
	local fundsData = DataCenter.fundsData;
	if fundsData.LockMap[self.selectType] == 0 then
		local fundsLvInfo = DataCenter.fundsUtil.fundsLvInfo;
		local rechargeId = fundsLvInfo.grade_list[self.selectType][2];
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		if fundsData.maxDay[self.selectType] < fundsData.curDay then
			Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sSpecialFundsReward(self.selectType);
		else
			OperateAlert.showLangValue(203003);
		end
	end
end

function Lua_SpecialFundsPanel:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.selectType = 1;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_SpecialFundsItem = class("Lua_SpecialFundsItem", Lua_ListCell)
function Lua_SpecialFundsItem:ctor(p)
	self:superCall("ctor", p, "SpecialFundsItem_skin");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setSiblingIndex(2);
	self.itemIcon:setLocation(0, -17, 0);
	self.itemIcon:setScale(0.92, 0.92);

	self.itemBg:addLoadCompleteFun(self, self.onLoadCompletedFun);
end

function Lua_SpecialFundsItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	local fundsData = DataCenter.fundsData;
	if self.data.day <= fundsData.curDay then
		self.itemBg:setAltas("funds_atlas", "xui_czjz2_widget_4");
	else
		self.itemBg:setAltas("funds_atlas", "xui_czjz2_widget_3");
	end
	
	self.dayTxt.text = LanUtil.formateStr(203004, data.day);

	local fundsLvInfo = DataCenter.fundsUtil.fundsLvInfo;
	local length = #fundsLvInfo.world_reward;
	local worldLv = DataCenter.fundsData.worldLv; -- DataCenter.roleData.level;
	local rewardInfo;
	for i = 1, length do
		if worldLv >= fundsLvInfo.world_reward[i][1] and worldLv <= fundsLvInfo.world_reward[i][2] then
			rewardInfo = data.reward[i];
			break;
		end
	end
	if rewardInfo == nil then
		rewardInfo = data.reward[length];
	end
	local tvo = Lua_ToolVo.createToolVo(rewardInfo[1], rewardInfo[2]);
	self.itemIcon:setData(tvo);

	self.drawIcon:setEnable(self.data.day <= fundsData.maxDay[fundsData.recordType]);
	self:showRedDot(fundsData.LockMap[fundsData.recordType] == 1
		and data.day <= fundsData.curDay
		and data.day > fundsData.maxDay[fundsData.recordType]);
end

function Lua_SpecialFundsItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:setLocation(49, 67, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_SpecialFundsItem:onPressClick(go)
	local fundsData = DataCenter.fundsData;
	if fundsData.LockMap[fundsData.recordType] == 1
		and self.data.day <= fundsData.curDay
		and self.data.day > fundsData.maxDay[fundsData.recordType] then
			Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sSpecialFundsReward(fundsData.recordType);
	else
		DataCenter.packUtil:showItemInfo(self.itemIcon.data);
	end
end

function Lua_SpecialFundsItem:onLoadCompletedFun()
	self.itemBg:resetSize();
end

function Lua_SpecialFundsItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end