-- 英雄集结
Lua_HeroGatherPanel = class("Lua_HeroGatherPanel", Lua_DisplayObject);
function Lua_HeroGatherPanel:ctor(p)
	self:superCall("ctor", p, "HeroGatherPanel_skin");
end

function Lua_HeroGatherPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.heroNum = Lua_NumberImage.new(self.uitweenObj_2);
	self.heroNum.pivot = 0;
	self.heroNum.numOffsetX = -7;
	self.heroNum.numAtlas = "number";
	self.heroNum.preStr = "xui_yxjj_number_0";
	self.heroNum:setLocation(-87, 382, 0);

	self.heroStarNum = Lua_NumberImage.new(self.uitweenObj_2);
	self.heroStarNum.pivot = 0;
	self.heroStarNum.numOffsetX = -7;
	self.heroStarNum.numAtlas = "number";
	self.heroStarNum.preStr = "xui_yxjj_number_0";
	self.heroStarNum:setLocation(5, 382, 0);

	self.giftItemArr = Array();
	self.scrollContainer = UICreate.createScrollContainer(self.uitweenObj_2, 0, 0, 416, 152);
	self.scrollContainer.horizontal = false;
	self.scrollContainer.vertical = false;
	self.scrollContainer.movementTypeValue = 1;
	self.scrollContainer.elasticity = 0.3;
	self.scrollContainer.inertia = true;
	-- self.scrollContainer.siblingIndex = 0;
	self.scrollContainer:setScrollSize(0, 0);
	self.scrollContainer:setScrollPivot(4);
	self.scrollContainer:setScrollAnchor(0.5, 0.5, 0.5, 0.5);
	self.scrollContainer:setScrollPosition(0, 0, 0);
	self.scrollContainer:addMask(); -- 隐藏其他区域
	self.sub = self.scrollContainer.scrollContent;
	-- LuaUtil.setObjAnchor(self.scrollContainer.mainContent, UIUtils.Anchor.Bottom);
	LuaUtil.setObjPos(self.scrollContainer.mainContent, 0, 496, 0);

	self.tipsBtn:addClickFuntion(self, self.onShowTipsClick);
	self.leftBtn:addClickFuntion(self, self.onPreClick);
	self.rightBtn:addClickFuntion(self, self.onNextClick);
	self.drawBtn:addClickFuntion(self, self.onDrawRewardClick);
	self.uitweenImg_1:setLocation(-500, 897, 0);
	self.uitweenImg_2:setLocation(540, 816, 0);
	self.uitweenImg_1:setEnable(false);
	self.uitweenImg_2:setEnable(false);
	self.uitweenImg_3:setEnable(false);
	self.uitweenImg_1:addLoadCompleteFun(self, self.onLoadCompletedFun_1);
	self.uitweenImg_2:addLoadCompleteFun(self, self.onLoadCompletedFun_2);
	self.uitweenImg_3:addLoadCompleteFun(self, self.onLoadCompletedFun_3);
	self.uitweenImg_1:setUrl("/images/activities/xui_yxjj_widget_7.png");
	self.uitweenImg_2:setUrl("/images/activities/xui_yxjj_widget_6.png");
	self.uitweenImg_3:setUrl("/images/activities/xui_yxjj_widget_1.png");

	self:addLuaEvent("UPDATE_HEROGATHER_INFO", self, self.updateHeroGatherInfo);
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sHeroGatherInfo();
end

function Lua_HeroGatherPanel:setData(data)
end

function Lua_HeroGatherPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_HeroGatherPanel:updateHeroGatherInfo()
	local heroGatherData = DataCenter.heroGatherData;
	self.curTaskId = heroGatherData.curTaskId;
	self.curIndex = heroGatherData.curTaskId;

	local heroGatherInfoArr = heroGatherData.heroGatherInfoArr;
	local item;
	for i = 1, heroGatherInfoArr:getSize() do
		item = self.giftItemArr[i];
		if item == nil then
			item = Lua_HeroGatherRewardItem.new(self.sub);
			self.giftItemArr:add(item);
		end
		item.contentName = "Lua_HeroGatherRewardItem" .. i;
		item:setData(heroGatherInfoArr[i]);
		item:setLocation((i - 1) * 416, 0, 0);
	end

	self:updateShow(self.curTaskId);
	self:startTimer();
	self:updateLeftTime();
end

function Lua_HeroGatherPanel:updateShow(toTaskId)
	self.phaseTxt_2.text = self.curIndex;

	local arr = DataCenter.heroGatherData.heroGatherInfoArr;
	self.heroNum.num = arr[self.curIndex].target_num;
	self.heroStarNum.num = arr[self.curIndex].star;
	
	local toIndex = toTaskId ~= nil and toTaskId or self.curIndex;
	self:playHGTween(toIndex, toTaskId == nil);
	-- print("idx", toIndex);

	local state = DataCenter.heroGatherData.heroGatherList[self.curIndex].state;
	if state == 0 then
		self.drawBtn:setLangValue(203402);
	elseif state == 1 then
		self.drawBtn:setLangValue(203403);
	elseif state == 2 then
		self.drawBtn:setLangValue(203404);
	end
	self.drawBtn:setGray(state == 2); -- self.curTaskId == arr:getSize()
	self.rightBtn:setEnable(self.curIndex < arr:getSize());
	self.leftBtn:setEnable(self.curIndex > self.curTaskId);
	self:showRedDot(state == 1);
end

function Lua_HeroGatherPanel:playHGTween(showIdx, isMove)
	-- print(self.preIdx, showIdx);
	if self.preIdx == showIdx then
		return;
	end

	if not isMove then
		LuaUtil.setObjPos(self.sub, -(showIdx - 1) * 416, 0, 0);
	else
		self:stopHGTween();
		-- self.isClick = true; -- 不加限制
		local posX = -(showIdx - 1) * 416;
		-- posX = self.preIdx < showIdx and -posX or posX;
		TweenUtil.getInstance():addTween(self.sub, 2, 0,
		posX, 0, 0,
		0, 0, 0,
		1, 1, 1,
		self, self.stopHGTween, 0, false);
	end
	self.preIdx = showIdx;
end

function Lua_HeroGatherPanel:stopHGTween()
	-- self.isClick = false;
	TweenUtil.getInstance():stop(self.sub);
end

function Lua_HeroGatherPanel:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.uitweenObj_2);
			self.redPoint:setLocation(108, 283, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_HeroGatherPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_HeroGatherPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_HeroGatherPanel:updateLeftTime()
	local remainTime = DataCenter.heroGatherData.endTick - DataCenter.roleData.serverTime;
	if remainTime <= 0 then
		remainTime = 0;
		self:endTimer();
	end
	local colorStr = remainTime > 86400 and "0FFF31" or "DA0303";
	self.leftTimeTxt.text = LanUtil.formateStr(203400, colorStr, Lua_TimeTransform.transSeconds16(remainTime, true, false, false));
end

function Lua_HeroGatherPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_HeroGatherPanel:onShowTipsClick(go)
	local tipsData = { des = LanUtil.getValue(203401), posX = 175, posY = -260 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroGatherPanel:onPreClick()
	if self.curIndex <= 1 or self.isClick then
		return;
	end
	self.curIndex = self.curIndex - 1;
	self:updateShow();
end

function Lua_HeroGatherPanel:onNextClick()
	if self.curIndex >= DataCenter.heroGatherData.heroGatherInfoArr:getSize() or self.isClick then
		return;
	end
	self.curIndex = self.curIndex + 1;
	self:updateShow();
end

function Lua_HeroGatherPanel:onDrawRewardClick()
	local heroGatherData = DataCenter.heroGatherData;
	local constConfig = heroGatherData.heroGatherConstConfig;
	if heroGatherData.heroGatherList[self.curIndex].state == 0 then
		DataCenter.funcPathUtil:gotoFunction(constConfig.return_id, true)
	elseif heroGatherData.heroGatherList[self.curIndex].state == 1 then
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sReceiveActiveGift();
	elseif heroGatherData.heroGatherList[self.curIndex].state == 2 then
		OperateAlert.showLangValue(203405);
	end
end

function Lua_HeroGatherPanel:onLoadCompletedFun_1(go)
	self.uitweenImg_1:setEnable(true);
	TweenUtil.getInstance():addTweenTargetPos(self.uitweenImg_1.mainContent, 0.5, 0, -193, 897, 0);
end

function Lua_HeroGatherPanel:onLoadCompletedFun_2(go)
	self.uitweenImg_2:setEnable(true);
	TweenUtil.getInstance():addTweenTargetPos(self.uitweenImg_2.mainContent, 0.5, 0, 123, 816, 0);
end

function Lua_HeroGatherPanel:onLoadCompletedFun_3(go)
	self.uitweenImg_3:setEnable(true);
end

function Lua_HeroGatherPanel:dispose()
	if self.giftItemArr ~= nil then
		self.giftItemArr:dispose();
		self.giftItemArr:clear();
		self.giftItemArr = nil;
	end
	if self.scrollContainer ~= nil then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.sub = nil;
	self:endTimer();
	self:stopHGTween();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_HeroGatherRewardItem = class("Lua_HeroGatherRewardItem", Lua_ListCell)
function Lua_HeroGatherRewardItem:ctor(p)
	self:superCall("ctor", p, "HeroGatherRewardItem_skin");

	self.rewardList = Lua_DragList.new(self.content, 416, 124, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ItemIconCell, 146, 124, 1);
	self.rewardList:setLocation(0, 14, 0);
end

function Lua_HeroGatherRewardItem:setData(data)
	if data == nil then
		return;
	end

	local width = 146 * #data.reward_item > 416 and 416 or 146 * #data.reward_item;
	self.rewardList.canDrag = #data.reward_item > 3;
	self.rewardList:setContentRect(width, 124);
	self.rewardList:setArrayData(data.reward_item);

	local info = DataCenter.heroGatherData.heroGatherList[data.id];
	for i = 1, #data.reward_item do
		self.rewardList.showDragDataList[i].cell.itemIcon:setDrawMask(info.state == 2);
	end

	local rewardInfo = DataCenter.heroGatherData.heroGatherInfoArr[data.id];
	self.progressBar:setMaxValue(rewardInfo.target_num);
	self.progressBar:setValue(info.progress);
	self.progressBar:setText(info.progress .."/".. rewardInfo.target_num);
	-- print(data.id, #data.reward_item, info.progress, rewardInfo.target_num)
end

function Lua_HeroGatherRewardItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self:superCall("dispose");
end