--成长投资
Lua_InvestmentPanel = class("Lua_InvestmentPanel", Lua_DisplayObject)
function Lua_InvestmentPanel:ctor(p)
	self:superCall("ctor", p, "InvestmentPanel_skin");
end

function Lua_InvestmentPanel:buildShowItem()
	self:superCall("buildShowItem");
    
    self.isFirstUpdate = true; --第一次更新界面，即刚打开界面
    self.immediately = true; --true:直接定位  false:缓动定位
    self.showStep = 1; --当前显示阶段

	self.dragList = Lua_DragList.new(self.content, 670, 700 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.dragList:setListCell(Lua_InvestmentItem, 670, 125, 1);
	self.dragList:setLocation(0, -470);
	self.dragList:setRectAnchor(1);
	self.dragList:setRectPivot(1);
	self.dragList.tweenId = 2025;
	self.dragList.delayTween = true;

	self.helpBtn:addClickFuntion(self, self.onHelpClick);
	self.previousIcon:addClickFuntion(self, self.onPressClick);
	self.nextIcon:addClickFuntion(self, self.onNextClick);

	self:addLuaEvent("UPDATE_INVESTMENT_PANEL", self, self.toUpdatePanel);

	self:toUpdatePanel();
end

function Lua_InvestmentPanel:toUpdatePanel()
	if self.isFirstUpdate == true then
		self.isFirstUpdate = false;
		local defaultStep = DataCenter.investmentData.defaultStep;
		self:updatePanel(defaultStep);
	else
		self:updatePanel(self.showStep);
	end
end

function Lua_InvestmentPanel:updatePanel(step)
	if step == nil then
		return;
	end
	self.showStep = step;

	local arr = DataCenter.investmentData:getIdArrByStep(step);
	self.dragList:setArrayData(arr);
	self.dragList.showTween = true;
    
    local index;
    local allEtraMoney = 0;
    local vo;
	for i = arr:getSize(), 1, -1 do
		vo = DataCenter.investmentData:getInvestmentVo(arr[i])
		if vo ~= nil then
			if vo.state == 1 or vo.seniorState == 1 then
				index = i;
			end
			allEtraMoney = allEtraMoney + vo.extraMoney;
		end
	end
	self.moneyNumTxt.text = allEtraMoney;
	if index ~= nil then
		self.dragList:moveToIndex(index, self.immediately);
	else
		if self.immediately == true then
			self.dragList:moveToIndex(1, true);
		end
	end
	self.immediately = false;

    local curStep = DataCenter.investmentData.curStep;
	if self.showStep <= 1 then
		self.previousIcon:setEnable(false);
	else
		self.previousIcon:setEnable(true);
	end
	if self.showStep >= curStep then
		self.nextIcon:setEnable(false);
	else
		self.nextIcon:setEnable(true);
	end

	local rechargeId = DataCenter.investmentData:getRechargeId(step);
	if rechargeId == nil then
		return;
	end
	self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
	if vo ~= nil then
		if vo.isUnlock == 1 then
			self.lockIcon:setEnable(false);
			self.buyTxt:setLangValue(202200);
			self.buyBtn:setAltas("common_altas_3", "xui_common_button_027_d");
			self.buyBtn:removeClickFuntion(self, self.onBuyClick);
		else
			self.lockIcon:setEnable(true);
			self.buyBtn:setAltas("common_altas_3", "xui_common_button_027_n");
			self.buyTxt.text = LanUtil.formateStr(202201, self.rechargeInfo.money);
			self.buyBtn:addClickFuntion(self, self.onBuyClick);
		end
	end
end

function Lua_InvestmentPanel:onPressClick()
	self.immediately = true; --阶段切换不需要缓动定位，直接定位

	if self.showStep > 1 then
		self:updatePanel(self.showStep - 1);
	end
end

function Lua_InvestmentPanel:onNextClick()
	self.immediately = true; --阶段切换不需要缓动定位，直接定位

	local curStep = DataCenter.investmentData.curStep;
	if self.showStep < curStep then
		self:updatePanel(self.showStep + 1);
	end
end

function Lua_InvestmentPanel:onHelpClick()
	local tipsData = {des = LanUtil.getValue(202202), posX = 27, posY = -320};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_InvestmentPanel:onBuyClick()
	if self.rechargeInfo == nil then
		return;
	end
	DataCenter.sdkInterface:PointOut(1, tonumber(self.rechargeInfo.money), tonumber(self.rechargeInfo.money_type),
		tonumber(self.rechargeInfo.id), self.rechargeInfo.gift_name, self.rechargeInfo.gold);
end

function Lua_InvestmentPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	if self.dragList ~= nil then
		self.dragList:setContentRect(720, 700 + adaptHeight);
	end
end

function Lua_InvestmentPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end










Lua_InvestmentItem = class("Lua_InvestmentItem", Lua_ListCell)
function Lua_InvestmentItem:ctor(p)
	self:superCall("ctor", p, "InvestmentItem_skin");
end

function Lua_InvestmentItem:buildShowItem()
	self:superCall("buildShowItem");

	self.baseIconList = Lua_ItemIconList.new(self.content);
	self.extraIconList = Lua_ItemIconList.new(self.content);
	self.baseIconList:setLocation(-108, 2);
	self.extraIconList:setLocation(174, 2);
	self.baseIconList.scaleVal = 0.75;
	self.extraIconList.scaleVal = 0.75;
end

function Lua_InvestmentItem:setData(id)
	self.data = DataCenter.investmentData:getInvestmentVo(id);
	local level = DataCenter.roleData.level;

	self.baseIconList:setArrayData(self.data.baseVoArr);
	self.extraIconList:setArrayData(self.data.extraVoArr);

	for i = 1, self.baseIconList.showArr:getSize() do
		self.baseIconList.showArr[i]:showRedPoint(self.data.state == 1);
	end
	for i = 1, self.extraIconList.showArr:getSize() do
		self.extraIconList.showArr[i]:showRedPoint(self.data.seniorState ~= 2 and level >= self.data.level);
	end
    
	self.baseIconList:setItemDrawMaskState(self.data.state == 2, "investment_atlas", "xui_czjz_label_1");
	self.extraIconList:setItemDrawMaskState(self.data.seniorState == 2, "investment_atlas", "xui_czjz_label_1");
	self.extraIconList:setItemMaskState(self.data.isUnlock ~= 1);

	local nextLevel;
	local interval
	if self.data.nextVo ~= nil then
		nextLevel = self.data.nextVo.level;
	    interval = level - self.data.level;
		if interval > nextLevel - self.data.level then
			interval = nextLevel - self.data.level;
		end
	end

	if level < self.data.level then
		self.levelBg:setAltas("investment_atlas", "xui_czjz_widget_7");
		self.levelTxt.colorStr = Lua_ColorDefine.transColorStr("ffffff");
    	self.lineBar:setEnable(false);
    else
    	self.levelBg:setAltas("investment_atlas", "xui_czjz_widget_6");
    	self.levelTxt.colorStr = Lua_ColorDefine.transColorStr("6b3823");
    	self.lineBar:setEnable(true);
    	if interval ~= nil and nextLevel ~= nil then
	    	self.lineBar:SetDimensions(20, interval/(nextLevel - self.data.level) * 46);
	    end
    end
    if self.data.nextVo == nil then
    	self.lineBar:setEnable(false);
    	self.lineBg:setEnable(false);
    else
    	self.lineBg:setEnable(true);
    end

	self.levelTxt.text = LanUtil.formateStr(202206, self.data.level);
end

function Lua_InvestmentItem:onBaseIconClick()
	if self.data.state == 0 then
		OperateAlert.showLangValue(202203);
	elseif self.data.state == 1 then
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sInvestmentDraw(self.data.id);
	else
		OperateAlert.showLangValue(202204);
	end
end

function Lua_InvestmentItem:onExtraIconClick()
	if self.data.seniorState == 0 then
		OperateAlert.showLangValue(202205);
	elseif self.data.seniorState == 1 then
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sInvestmentDraw(self.data.id);
	else
		OperateAlert.showLangValue(202204);
	end
end

function Lua_InvestmentItem:onPressClick()
	if self.pressItem == nil or self.clickType == nil then
		return;
	end

	if self.clickType == 1 then
		self:onBaseIconClick();
	else
		self:onExtraIconClick();
	end
end

function Lua_InvestmentItem:checkClick()
	local winPosB = LuaUtil.getTouchPosInverseObj(self.baseIconList.mainContent);
    for i = 1, self.baseIconList.showArr:getSize() do
        if self.baseIconList.showArr[i].isActive and self.baseIconList.showArr[i]:checkInBound(winPosB.x, winPosB.y) then
            self.clickType = 1;
            return self.baseIconList.showArr[i];
        end
    end

    local winPosE = LuaUtil.getTouchPosInverseObj(self.extraIconList.mainContent);
    for i = 1, self.extraIconList.showArr:getSize() do
        if self.extraIconList.showArr[i].isActive and self.extraIconList.showArr[i]:checkInBound(winPosE.x, winPosE.y) then
            self.clickType = 2;
            return self.extraIconList.showArr[i];
        end
    end
    
    self.clickType = nil;
    return nil;
end

function Lua_InvestmentItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.71, 0.71);
	end
end

function Lua_InvestmentItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.75, 0.75);
	end
end

function Lua_InvestmentItem:dispose()
	if self.baseIconList ~= nil then
		self.baseIconList:dispose();
		self.baseIconList = nil;
	end
	if self.extraIconList ~= nil then
		self.extraIconList:dispose();
		self.extraIconList = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end
end