-- 月卡
Lua_MonthCardPanel = class("Lua_MonthCardPanel", Lua_DisplayObject);
function Lua_MonthCardPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_MonthCardPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.titleIcon = UICreate.createImage(self.content, "/images/activities/xui_yk_zi_1.png", 166, -298, 0, 0);
	self.titleIcon.anchorValue = 1;

	self.cardList = Lua_DragList.new(self.content, 714, 787, Lua_AxisDefine.Horizontal);
	self.cardList.tweenId = 2022;
	self.cardList:setListCell(Lua_MonthCardItem, 357, 787, 1);
	self.cardList:setLocation(0, -113, 0);

	self:addLuaEvent("UPDATE_MONTHCARD_INFO", self, self.updateMonthCardInfo);
	Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sMonthCardInInfo();
end

function Lua_MonthCardPanel:setData(data)
end

function Lua_MonthCardPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_MonthCardPanel:updateMonthCardInfo()
	self.cardList:setArrayData(DataCenter.monthCardData.monthCardDic);
	self.cardList.canDrag = #DataCenter.monthCardData.monthCardDic > 2;
end

function Lua_MonthCardPanel:dispose()
	if self.titleIcon ~= nil then
		self.titleIcon:dispose();
		self.titleIcon = nil;
	end
	if self.cardList ~= nil then
		self.cardList:dispose();
		self.cardList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_MonthCardItem = class("Lua_MonthCardItem", Lua_ListCell);
function Lua_MonthCardItem:ctor(p)
    self:superCall("ctor", p, "MonthCardItem_skin");
end

function Lua_MonthCardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.receiveBtn:addClickFuntion(self, self.onActiveClick);
end

function Lua_MonthCardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.itemBg:setUrl(data.card_bg);
	self.cardIcon:setAltas(data.icon_atlas, data.icon_sprite);

	self.dailyNum.text = data.reward[2];
	self.totalNum.text = data.total_Reward;
	self.tips.text = LanUtil.formateStr(202400, data.residue_Days);
	self.tips:setLocation(0, -236, 0);
	
	if data.draw_State == 0 then
		self.receiveBtn:setLangValue(202402);

		self.progressBar:setMaxValue(data.total_recharge);
		self.progressBar:setValue(data.aggregatment);
		self.progressBar:setText(LanUtil.formateStr(202404, tostring(data.aggregatment), tostring(data.total_recharge)));

		self.tips.text = LanUtil.formateStr(202405, tostring(data.total_recharge));
	elseif data.draw_State == 1 then
		self.receiveBtn:setLangValue(202401);
	else
		self.tips:setLocation(0, -210, 0);
		self.receiveBtn:setLangValue(202403);
	end
	
	self.progressBar:setEnable(data.draw_State == 0);
	self.receiveBtn:setGray(data.draw_State == 2 and true or false);
	self.receiveBtn:setEnable(data.draw_State ~= 2);
	self.drawedIcon:setEnable(data.draw_State == 2);
	self:showRedDot(data.draw_State == 1);
end

function Lua_MonthCardItem:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(108, -275, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_MonthCardItem:onActiveClick()
	if self.data.draw_State == 0 then
		DataCenter.funcPathUtil:gotoFunction(1024);
	elseif self.data.draw_State == 1 then
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sGetMonthCardReward(self.data.grade);
	-- else
	-- 	OperateAlert.showLangValue(202403);
	end
end

function Lua_MonthCardItem:dispose()
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end