-- 新服专享
Lua_NewServeGiftPanel = class("Lua_NewServeGiftPanel", Lua_DisplayObject);
function Lua_NewServeGiftPanel:ctor(p)
	self:superCall("ctor", p, "NewServeGiftPanel_skin");
end

function Lua_NewServeGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBg:SetDimensions(699, 943 + self.adaptHeight);

	self.giftList = Lua_DragList.new(self.content, 672, 818 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_NewServeGiftItem, 672, 181, 1);
	self.giftList:setCellSpacing(0, 5);
	self.giftList:setLocation(0, -110, 0);

	self:addLuaEvent("UPDATE_NEWSERVEGIFT_INFO", self, self.updateNewServeGiftShow);
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sNewServeGiftInfo(1);
end

function Lua_NewServeGiftPanel:setData(data)
end

function Lua_NewServeGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	
	self.rewardBg:SetDimensions(699, 943 + adaptHeight);
	self.giftList:setContentRect(672, 818 + adaptHeight);
end

function Lua_NewServeGiftPanel:updateNewServeGiftShow()
	self.giftList:setArrayData(DataCenter.newServeGiftData.newServeGiftArr);

	self.remainTime = DataCenter.newServeGiftData.remainTime;
	self:startTimer();
	self:updateLeftTime();
end

function Lua_NewServeGiftPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_NewServeGiftPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_NewServeGiftPanel:updateLeftTime()
	self.remainTime = self.remainTime - 1;
	if self.remainTime <= 0 then
		self.remainTime = 0;
		self:endTimer();
	end
	self.leftTimeTxt.text = LanUtil.formateStr(203300, Lua_TimeTransform.transSeconds18(self.remainTime, true, true, true, false))
end

function Lua_NewServeGiftPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_NewServeGiftPanel:dispose()
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_NewServeGiftItem = class("Lua_NewServeGiftItem", Lua_ListCell);
function Lua_NewServeGiftItem:ctor(p)
	self:superCall("ctor", p, "NewServeGiftItem_skin");
end

function Lua_NewServeGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardList = Lua_DragList.new(self.content, 402, 93, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_NewServeGiftSubItem, 93, 93, 1);
	self.rewardList:setCellSpacing(13, 0);
	self.rewardList:setLocation(-98, -11, 0);
	self:setSubList(self.rewardList);

	self.stateBtn:addClickFuntion(self, self.onBtnClick);
end

function Lua_NewServeGiftItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	
	self.tipsTxt.text = data.title;
	self.rewardList.canDrag = #data.reward > 3;
	self.rewardList:setArrayData(data.reward);

	self.limitCountTxt.text = LanUtil.formateStr(203301, data.limitTimes, data.limit_times);
	if data.recharge == 0 then
		self.stateBtn:setLangValue(203302);
	else
		self.stateBtn.label = LanUtil.formateStr(203303, data.recharge);
	end
	self.limitCountTxt:setEnable(data.limitTimes > 0);
	self.stateBtn:setEnable(data.limitTimes > 0);
	self.selloutIcon:setEnable(data.limitTimes <= 0);
	self:showRedDot(data.recharge == 0 and data.limitTimes > 0);
end

function Lua_NewServeGiftItem:showRedDot(showState)
	if showState then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setLocation(287, -9, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_NewServeGiftItem:onBtnClick()
	if self.data.recharge ~= 0 then
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data.id);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	else
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sGetNewServeReward(self.data.id);
	end
end

function Lua_NewServeGiftItem:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end










Lua_NewServeGiftSubItem = class("Lua_NewServeGiftSubItem", Lua_ItemIconCell);
function Lua_NewServeGiftSubItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_NewServeGiftSubItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon:setScale(0.75, 0.75);
end