-- 开服试炼-英雄赠礼
Lua_OpenServerHeroGiftPanel = class("Lua_OpenServerHeroGiftPanel", Lua_DisplayObject);
function Lua_OpenServerHeroGiftPanel:ctor(p)
	self:superCall("ctor", p, "OpenServerHeroGiftPanel_skin");
end

function Lua_OpenServerHeroGiftPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.showItemArr = Array();
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	openServerHeroGiftData.isOpen = 1;

	local itemInfo = getConfig("item", openServerHeroGiftData.drawItemId);
	self.itemIcon_1:setAltas(itemInfo.atlas, itemInfo.sprite);
	self.itemIcon_2:setAltas(itemInfo.atlas, itemInfo.sprite);

	self.redPoint = Lua_RedPointIcon.new(self.content, Lua_RedPointList.OpenServerTrial_HeroGift);
	self.redPoint:setLocation(98, -230, 0);
	
	self.btnList = Lua_DragList.new(self.content, 710, 148, Lua_AxisDefine.Horizontal);
	self.btnList:setListCell(Lua_OpenServerHeroGiftBtnItem, 234, 148, 1);
	self.btnList:setCellSpacing(4, 0);
	self.btnList:setLocation(0, -448, 0);

	self.addBtn:addClickFuntion(self, self.onAddClick);
	self.drawBtn:addClickFuntion(self, self.onDrawClick);

	self:addLuaEvent("MONEY_UPDATE", self, self.updateItemNumShow); -- 货币数量增加时更新红点
	self:addLuaEvent("UPDATE_OPENSERVER_HEROGIFT_INFO", self, self.updateOpenServerHeroGiftData);
	-- Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sOpenServerHeroGiftInfo();
	self:updateOpenServerHeroGiftData();
end

function Lua_OpenServerHeroGiftPanel:setData(data)
end

function Lua_OpenServerHeroGiftPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_OpenServerHeroGiftPanel:updateOpenServerHeroGiftData()
	self:starTimer();
	self:updateTimer();
	self:updateItemNumShow();

	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local isPlay = openServerHeroGiftData.isPlayTween;
	local arr = openServerHeroGiftData:curPhaseShowArr();
	if isPlay then
		openServerHeroGiftData.isPlayTween = false;
		
		self.selectTab = {};
		for i = 1, arr:getSize() do
			if not arr[i].isDrawed or (arr[i].isDrawed and arr[i].id == openServerHeroGiftData.cell_num) then
				self.selectTab[#self.selectTab + 1] = i;
			end
		end

		if #self.selectTab > 1 then
			self.startNum = 0;
			self.circleNum = arr:getSize();
			self.endPos = openServerHeroGiftData.cell_num % 10000;
			self:startPlayTween();
			self:updatePlyaTween();
		else
			self.endPos = openServerHeroGiftData.cell_num % 10000;
			self.lightTimes = 5;
			self.showOrHide = true;
			self.showItemArr[self.endPos]:setShowHide(self.showOrHide);
			self:startPlayLight();
		end
	else
		local posX;
		local posY;
		local vo;
		for i = 1, arr:getSize() do
			posX = -276 + ((i - 1) % 5) * 138;
			posY = 280 - Mathf.Ceil(i / 5) * 134;

			item = self.showItemArr[i];
			if item == nil then
				item = Lua_OpenServerHeroGiftItem.new(self.content);
				item:setLocation(posX, posY);
				self.showItemArr:add(item);
			end
			item:setData(arr[i]);
		end
	end

	if self.round_num ~= openServerHeroGiftData.round_num then
		self.btnList.canDrag = #openServerHeroGiftData.entranceList > 3;
		self.btnList:setArrayData(openServerHeroGiftData.entranceList);
	end
	self.round_num = openServerHeroGiftData.round_num;
end

function Lua_OpenServerHeroGiftPanel:starTimer()
	if self.timeCountDown ~= true then
		self.timeCountDown = true;
		self:addTimer("PlayTime", 1, self, self.updateTimer);
	end
end

function Lua_OpenServerHeroGiftPanel:updateTimer()
	local time = Mathf.Ceil(DataCenter.openServerHeroGiftData.end_time - DataCenter.roleData.serverTime);
	self.leftTimeTxt.text = LanUtil.formateStr(660000, Lua_TimeTransform.transSeconds1(time, true, true, true));
	if time < 0 then
		self:endTimer();
	end
end

function Lua_OpenServerHeroGiftPanel:endTimer()
	if self.timeCountDown == true then
		self.timeCountDown = false;
		self:removeTimer(self, self.updateTimer);
	end
end

function Lua_OpenServerHeroGiftPanel:updateItemNumShow()
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local hasCount = DataCenter.packData:getItemCountById(openServerHeroGiftData.drawItemId);
	local needCount = openServerHeroGiftData.drawItemNum;
	local arr = openServerHeroGiftData:curPhaseShowArr();
	if needCount == 0 then
		self.numTxt:setLangValue(660001);
		self.drawBtn:setLangValue(660003);
	else
		local colorStr = hasCount >= needCount and "3A9F3C" or "ED4C30";
		self.numTxt.text = LanUtil.formateStr(660002, colorStr, hasCount, needCount);

		local itemInfo = Lua_ToolVo.createToolVo(openServerHeroGiftData.drawItemId);
		local itemStr = spliceIconStr(itemInfo.atlas, itemInfo.sprite, itemInfo.iconWidth, itemInfo.iconHeight);
		self.drawBtn.label = spliceStr(itemStr, needCount, LanUtil.getValue(660004));
	end
	self.drawBtn:setGray(arr:getSize() <= openServerHeroGiftData.draw_num);
end

function Lua_OpenServerHeroGiftPanel:startPlayTween()
	if self.tweenCountDown ~= true then
		self.tweenCountDown = true;
		self:addTimer("PlayTween", 0.1, self, self.updatePlyaTween);
	end
end

function Lua_OpenServerHeroGiftPanel:updatePlyaTween()
	self.startNum = self.startNum + 1;
	self.prePos = self.curPos;

	if self.startNum >= self.circleNum + self.endPos then
		self:endPlayTween();

		self.lightTimes = 5;
		self.showOrHide = true;
		self.curPos = self.endPos;
		self:startPlayLight();
	else
		local idx = Mathf.Random(1, #self.selectTab);
		self.curPos = self.selectTab[idx];
		if self.curPos == self.prePos then
			idx = idx + 1 > #self.selectTab and 1 or idx + 1;
			self.curPos = self.selectTab[idx];
		end
	end

	if self.startNum > 1 then
		self.showItemArr[self.prePos]:setShowHide(false);
	end
	self.showItemArr[self.curPos]:setShowHide(true);
end

function Lua_OpenServerHeroGiftPanel:endPlayTween()
	if self.tweenCountDown == true then
		self.tweenCountDown = false;
		self:removeTimer(self, self.updatePlyaTween);
	end
end

function Lua_OpenServerHeroGiftPanel:startPlayLight()
	if self.lightCountDown ~= true then
		self.lightCountDown = true;
		self:addTimer("PlayLight", 0.1, self, self.updatePlayLight);
	end
end

function Lua_OpenServerHeroGiftPanel:updatePlayLight()
	self.lightTimes = self.lightTimes - 1;
	self.showOrHide = not self.showOrHide;
	self.showItemArr[self.endPos]:setShowHide(self.showOrHide);
	if self.lightTimes <= 1 then
		self:endPlayLight();
	end
end

function Lua_OpenServerHeroGiftPanel:endPlayLight()
	if self.lightCountDown == true then
		self.lightCountDown = false;
		self:removeTimer(self, self.updatePlayLight);
		self:showReward();
	end
end

function Lua_OpenServerHeroGiftPanel:showReward()
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local info = openServerHeroGiftData.heroGiftDic[openServerHeroGiftData.cell_num].reward_item;
	local tvo = Lua_ToolVo.createToolVo(info[1], info[2]);
	if openServerHeroGiftData.heroInfo ~= nil and tvo.hero_id == openServerHeroGiftData.heroInfo.hero_id then
		tvo.isNew = openServerHeroGiftData.heroInfo.is_new;
	end

	local rewardArr = Array();
	rewardArr:add(tvo);
	Lua_WindowUtil.openWin("Lua_OpenServerShowRewardWindow", Lua_WinParam.ACTION_OPEN, rewardArr);
end

function Lua_OpenServerHeroGiftPanel:onAddClick(go)
	DataCenter.packUtil:openPathWindow(DataCenter.openServerHeroGiftData.drawItemId, false);
end

function Lua_OpenServerHeroGiftPanel:onDrawClick(go)
	local openServerHeroGiftData = DataCenter.openServerHeroGiftData;
	local hasCount = DataCenter.packData:getItemCountById(openServerHeroGiftData.drawItemId);
	local needCount = openServerHeroGiftData.drawItemNum;
	if hasCount >= needCount then
		local arr = openServerHeroGiftData:curPhaseShowArr();
		if arr:getSize() > openServerHeroGiftData.draw_num then
			Lua_ProxyManager.getProxy("Lua_OpenServerTrialProxy"):sDrawOpenServerHeroGift();
		end
	else
		DataCenter.packUtil:openPathWindow(DataCenter.openServerHeroGiftData.drawItemId, false);
	end
end

function Lua_OpenServerHeroGiftPanel:dispose()
	if self.showItemArr ~= nil then
		self.showItemArr:dispose();
		self.showItemArr:clear();
		self.showItemArr = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self:endTimer();
	self:endPlayTween();
	self:endPlayLight();
	DataCenter.openServerHeroGiftData.isOpen = 0;

	self:superCall("dispose");
end










Lua_OpenServerHeroGiftItem = class("Lua_OpenServerHeroGiftItem", Lua_DisplayObject);
function Lua_OpenServerHeroGiftItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_OpenServerHeroGiftItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(true);

	self.selectIcon = UICreate.createUIAtlasImage(self.content, "online_atlas", "xui_zxjl_widget_4", 0, 0, 0, 0);
end

function Lua_OpenServerHeroGiftItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local tvo = Lua_ToolVo.createToolVo(data.reward_item[1], data.reward_item[2]);
	self.itemIcon:setData(tvo);
	self.itemIcon:setDrawMask(data.isDrawed);

	self.selectIcon:setEnable(false);
end

function Lua_OpenServerHeroGiftItem:setShowHide(state)
	self.selectIcon:setEnable(state);
end

function Lua_OpenServerHeroGiftItem:dispose()
	if self.itemIcon == nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.selectIcon == nil then
		self.selectIcon:dispose();
		self.selectIcon = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end










Lua_OpenServerHeroGiftBtnItem = class("Lua_OpenServerHeroGiftBtnItem", Lua_ListCell);
function Lua_OpenServerHeroGiftBtnItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_OpenServerHeroGiftBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemBg = UICreate.createUIAtlasImage(self.content, "trial_altas", "ui_shilian_widget_005", 0, 0, 0, 0);
end

function Lua_OpenServerHeroGiftBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.itemBg:setAltas(data[1], data[2]);
end

function Lua_OpenServerHeroGiftBtnItem:onPressClick()
	if self._data ~= nil and self._data[3] then
		local bCloseOther = self._data[4] == 1 or false;
		DataCenter.funcPathUtil:gotoFunction(tonumber(self._data[3]), bCloseOther);
	end
end

function Lua_OpenServerHeroGiftBtnItem:dispose()
	if self.itemBg ~= nil then
		self.itemBg:dispose();
		self.itemBg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end