--开服竞技
Lua_OpenServiceAthleticsPanel = class("Lua_OpenServiceAthleticsPanel", Lua_DisplayObject);
function Lua_OpenServiceAthleticsPanel:ctor(p)
	self:superCall("ctor", p, "OpenServiceAthletics_skin");
end

function Lua_OpenServiceAthleticsPanel:buildShowItem()
	self:superCall("buildShowItem");
	
	self.containerList = Lua_DragContainer.new(self.content, 0, 0, Lua_AxisDefine.Vertical);
	self.containerList:setRectAnchor(1);
	self.containerList.tweenId = 2014;
	self.containerList.delayTween = true;

	self.downTabInfo = Array();
    self.downTabInfo:add({textStr = LanUtil.getValue(400016), tagType = 1});
    self.downTabInfo:add({textStr = LanUtil.getValue(400017), tagType = 2});

    --奖励/排行页签
    self.downBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.downBtnList:setRectAnchor(7);
    self.downBtnList:setLocation(0, 210, 0);
    self.downBtnList:setButtonItem(130, 66);
    self.downBtnList:setButtonCell(Lua_OpenAthleticsButtonItem);
	self.downBtnList:setClickCallBack(self, self.onDownTabBtnClick);
    self.downBtnList:setData(self.downTabInfo);

	self.topTabInfo = Array();
    self.topTabInfo:add({textStr = LanUtil.getValue(400014), tagType = Lua_OpenServiceAthleticsData.STAR});
    self.topTabInfo:add({textStr = LanUtil.getValue(400015), tagType = Lua_OpenServiceAthleticsData.TIER});

    --星数/层数排行页签
    self.topBtnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.topBtnList:setRectAnchor(1);
    self.topBtnList:setLocation(-176, -367, 0);
    self.topBtnList:setButtonItem(190, 52);
    self.topBtnList:setButtonStyle("common_altas_4","xui_kfjj_toggle_002_b","xui_kfjj_toggle_002_f",176,52);
    self.topBtnList:setButtonText(0, 0, "f5dbb1", "8f5123", 28, 28, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.topBtnList:setClickCallBack(self, self.onTopTabBtnClick);
    self.topBtnList:setData(self.topTabInfo);
    self.topBtnList:setSelected(Lua_OpenServiceAthleticsData.STAR);--默认选择

	self:sendMsg(Lua_OpenServiceAthleticsData.STAR);
    
    self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);
	self:addLuaEvent("UPDATE_ATHLETICS_INFO", self, self.updateAthleticsPanel);
end

--星数/层数排行页签
function Lua_OpenServiceAthleticsPanel:onTopTabBtnClick(val)
	local tagType = self.topTabInfo[val].tagType;
	if self.selectTopType == tagType then
		return;
	end
    self.selectTopType = tagType;
    self.selectDownType = nil;
    self.downBtnList.selectedIdx = nil;
	self.downBtnList:setSelected(1);--默认选择
	self.title_spr:setAltas("open_athletics_atlas", "xui_kfjj_title_"..val);
	self:playTopTween();
end

--奖励/排行页签
function Lua_OpenServiceAthleticsPanel:onDownTabBtnClick(val)
	local tagType = self.downTabInfo[val].tagType;
	if self.selectDownType == tagType then
		return;
	end
    self.selectDownType = tagType;
    if tagType == 1 then
    	self:updateDragLsit(tagType);
    elseif tagType == 2 then
    	self:sendMsg(self.selectTopType);
    end
end

function Lua_OpenServiceAthleticsPanel:updateAthleticsPanel()
	self:startTimer();
	if self.selectDownType == 2 then
		self:updateDragLsit(self.selectDownType);
	end
end

function Lua_OpenServiceAthleticsPanel:updateDragLsit(select_type)
	self.containerList:clearList();
	local arr;
	if select_type == 1 then--奖励数据
		arr = DataCenter.OpenServiceAthleticsData:getRewardsInfo(self.selectTopType);
		for i = 1, arr:getSize() do
			self.containerList:addSubContainer(Lua_OpenServiceAthleticsRewardItem, arr[i]);
		end
		self.containerList:setCellSpacing(0, 10);
		self.containerList:setContentRect(698, 764 + self.adaptHeight);
	    self.containerList:setLocation(0, -790 - self.adaptHeight/2, 0, 0);

	    self.noRankObj:SetActive(false);
	    self.titleObj:SetActive(false);
		self.myRankObj:SetActive(false);
		if self.headItem ~= nil then
			self.headItem:setEnable(false);
		end
	elseif select_type == 2 then--排名数据
		arr = DataCenter.OpenServiceAthleticsData.rank_list;
		for i = 1, #arr do
			self.containerList:addSubContainer(Lua_OpenServiceAthleticsRankItem, arr[i]);
		end
		self.containerList:setCellSpacing(0, 6);
		self.containerList:setContentRect(694, 576 + self.adaptHeight);
	    self.containerList:setLocation(0, -739 - self.adaptHeight/2, 0, 0);

	    --arr = DataCenter.OpenServiceAthleticsData.rank_list;
	    self.titleObj:SetActive(true);
		self.myRankObj:SetActive(true);
		if self.selectTopType == Lua_OpenServiceAthleticsData.STAR then
			self.starOrTierText:setLangValue(400007);
		elseif self.selectTopType == Lua_OpenServiceAthleticsData.TIER then
			self.starOrTierText:setLangValue(400008);
		end

		self.noRankObj:SetActive(arr == nil or #arr <= 0);
		self:updateSelfRankInfo();
	end
	
	self.containerList:updateChildPos();
	self.containerList:moveToIndex(1,true);
	self.containerList.showTween = true;
end

function Lua_OpenServiceAthleticsPanel:playTopTween()
	LuaUtil.setObjPos(self.topObj, 0, -520, 0);
	TweenUtil.getInstance():stop(self.topObj);
	TweenUtil.getInstance():addTweenTargetPos(self.topObj, 0.5, 0, 0, -720, 0, 0, false);
end

--更新自己的排行信息
function Lua_OpenServiceAthleticsPanel:updateSelfRankInfo()
	self.data = DataCenter.OpenServiceAthleticsData.self_list;
	if self.data == nil then
		return;
	end
	local rank = self.data.rank == 0 and LanUtil.getValue(400011) or self.data.rank;
	local size = self.data.rank == 0 and 26 or 50;
	self.rank_txt.text = rank;
	self.rank_txt.fontSize = size;
	self.name_txt.text = self.data.player_show.name;

	local league_name = self.data.player_show.league_name;
	if league_name == nil or league_name == "" then
		self.tips_txt:setLangValue(400005);
    else
		self.tips_txt.text = LanUtil.formateStr(400004, league_name);
    end
    self.num_txt.text = self.data.value;

    if self.headItem == nil then
    	self.headItem = Lua_AvatarItem.new(self.content);
    	self.headItem:setRectAnchor(7);
    	self.headItem:setScale(0.75,0.75);
		self.headItem:setLocation(-156, 326);
	end
	self.headItem:setEnable(true);
	self.headItem:setRoleDressUp(self.data.player_show.dress_info);
	self.headItem:setRoleLevel(self.data.player_show.level);
    self.headItem:setAvatarClick(self, self.onHeadClick);
end

function Lua_OpenServiceAthleticsPanel:onHeadClick()
	if tonumber(self.data.player_show.id) == DataCenter.roleData.roleId then
		OperateAlert.showLangValue(400006);
	else
		Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data.player_show.id));
	end
end

function Lua_OpenServiceAthleticsPanel:startTimer()
	self.showTime = DataCenter.OpenServiceAthleticsData.end_time;-- - DataCenter.roleData.serverTime;
	local str = Lua_TimeTransform.transSeconds16(self.showTime - DataCenter.roleData.serverTime, true, true, true);
	self.activeTimeText.text = LanUtil.formateStr(400018, str);
	if self.bStarTimer ~= true then
		self.bStarTimer = true;
		self:addTimer("OnAthleticsTimeDown", 1, self, self.showActiveTime);
	end
end

function Lua_OpenServiceAthleticsPanel:showActiveTime()
	self.showTime = self.showTime - 1;
	local str = Lua_TimeTransform.transSeconds16(self.showTime - DataCenter.roleData.serverTime, true, true, true);
	self.activeTimeText.text = LanUtil.formateStr(400018, str);
	if self.showTime <= 0 then
		if self.bStarTimer == true then
			self.bStarTimer = false;
			Lua_CommonUtil.removeTimer(self, self.showActiveTime);
		end
	end
end

function Lua_OpenServiceAthleticsPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
	if self.selectDownType == nil or self.selectDownType == 1 then
		self.containerList:setContentRect(698, 764 + adaptHeight);
	    self.containerList:setLocation(0, -790 - adaptHeight/2, 0, 0);
	elseif self.selectDownType == 2 then
		self.containerList:setContentRect(694, 576 + adaptHeight);
	    self.containerList:setLocation(0, -739 - adaptHeight/2, 0, 0);
	end
	self.containerList:moveToIndex(1,true);
end

function Lua_OpenServiceAthleticsPanel:sendMsg(types)
	Lua_ProxyManager.getProxy("Lua_LimitedTimeActivityProxy"):sOpenServiceAthleticsInfo(types);
end

function Lua_OpenServiceAthleticsPanel:onHelpBtnClick()
	local tipData = {des = LanUtil.getValue(400019), posX = 204, posY = -217};
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_OpenServiceAthleticsPanel:dispose()
	if self.headItem ~= nil then
		self.headItem:dispose();
		self.headItem = nil;
	end

	if self.topBtnList ~= nil then
		self.topBtnList:dispose();
		self.topBtnList = nil;
	end

	if self.downBtnList ~= nil then
		self.downBtnList:dispose();
		self.downBtnList = nil;
	end

	if self.topTabInfo ~= nil then
		self.topTabInfo:dispose();
		self.topTabInfo = nil;
	end

	if self.downTabInfo ~= nil then
		self.downTabInfo:dispose();
		self.downTabInfo = nil;
	end

	if self.containerList ~= nil then
		self.containerList:dispose();
		self.containerList = nil;
	end
	self.data = nil;
	if self.bStarTimer == true then
		self.bStarTimer = false;
		Lua_CommonUtil.removeTimer(self, self.showActiveTime);
	end
	TweenUtil.getInstance():stop(self.topObj);
	self:superCall("dispose");
end





























Lua_OpenServiceAthleticsRewardItem = class("Lua_OpenServiceAthleticsRewardItem", Lua_DragContainerItem);
function Lua_OpenServiceAthleticsRewardItem:ctor(p)
	self:superCall("ctor", p, "OpenServiceAthleticsRewardItem_skin");
end

function Lua_OpenServiceAthleticsRewardItem:buildShowItem()
	self:superCall("buildShowItem");
	self.rewardIconList = Lua_ItemIconList.new(self.content);
	self.rewardIconList.pivot = 1;
	self.rewardIconList.scaleVal = 0.75;
	self.rewardIconList:setLayout(138, 0, 100);
	self.rewardIconList:setLocation(-274, -20, 0);
end

function Lua_OpenServiceAthleticsRewardItem:setData(id)
	self.data = DataCenter.OpenServiceAthleticsData:getOpenArenaVoById(id);
	if self.data == nil then
		return
	end

	local leftValue = self.data.range[1];
	local rightValue = self.data.range[2];
	self.rewardIconList:setArrayData(self.data.reward_item);
	if self.data.type == 1 then
		if leftValue == rightValue then
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400000, leftValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400012, leftValue);
		    end
		else
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400001, leftValue, rightValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400013, leftValue, rightValue);
		    end
		end  
	elseif self.data.type == 2 then
		if leftValue == rightValue then
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400002, leftValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400012, leftValue);
		    end
		else
			if self.data.complete ~= nil then
				self.rankText.text = LanUtil.formateStr(400003, leftValue, rightValue, self.data.complete);
		    else
				self.rankText.text = LanUtil.formateStr(400013, leftValue, rightValue);
		    end
		end
	end
end

function Lua_OpenServiceAthleticsRewardItem:onPressClick()
	if self.pressItem == nil then
		return;
	end
	self.pressItem:onItemClick(nil);
end

function Lua_OpenServiceAthleticsRewardItem:checkClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.rewardIconList.mainContent);
    for i = 1, self.rewardIconList.showArr:getSize() do
        if self.rewardIconList.showArr[i].isActive and self.rewardIconList.showArr[i]:checkInBound(winPos.x, winPos.y) then
            return self.rewardIconList.showArr[i];
        end
    end
    return nil;
end

function Lua_OpenServiceAthleticsRewardItem:onMouseDownHandle()
	self.pressItem = self:checkClick();
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.71, 0.71);
	end
end

function Lua_OpenServiceAthleticsRewardItem:onMouseUpHandle()
	if self.pressItem ~= nil then
		self.pressItem:setScale(0.75, 0.75);
	end
end

function Lua_OpenServiceAthleticsRewardItem:getWidth()
    return 698;
end

function Lua_OpenServiceAthleticsRewardItem:getHeight()
	return 170;
end


function Lua_OpenServiceAthleticsRewardItem:dispose()
	if self.rewardIconList ~= nil then
		self.rewardIconList:dispose();
		self.rewardIconList = nil;
	end
	if self.pressItem ~= nil then
		self.pressItem:dispose();
		self.pressItem = nil;
	end
	self:superCall("dispose");
end



























Lua_OpenServiceAthleticsRankItem = class("Lua_OpenServiceAthleticsRankItem", Lua_DragContainerItem)
function Lua_OpenServiceAthleticsRankItem:ctor(p)
	self:superCall("ctor", p, "OpenServiceAthleticsRankItem_skin");
end

function Lua_OpenServiceAthleticsRankItem:buildShowItem()
	self:superCall("buildShowItem");
	self.headItem = Lua_AvatarItem.new(self.content);
	self.headItem:setScale(0.75,0.75);
	self.headItem:setLocation(-156, 0);
end

function Lua_OpenServiceAthleticsRankItem:setData(data)
	self.data = data;
	if self.data == nil then
		return
	end

	if self.data.rank <= 3 then
		self.rankNumText:setEnable(false);
		self.rank_icon:setAltas("common_altas_4","xui_jys_label_"..9 + self.data.rank);
	else
		self.rankNumText.text = self.data.rank;
		self.rankNumText:setEnable(true);
		self.rank_icon:setAltas("common_altas_4","xui_jys_label_13");
	end

	self.nameText.text = self.data.player_show.name;

	local league_name = self.data.player_show.league_name;
	if league_name == nil or league_name == "" then
		self.communityText:setLangValue(400005);
    else
		self.communityText.text = LanUtil.formateStr(400004, league_name);
    end
    self.starNumText.text = self.data.value;

    self.headItem:setRoleDressUp(self.data.player_show.dress_info);
    self.headItem:setRoleLevel(self.data.player_show.level);
    self.headItem:setAvatarClick(self, self.onHeadClick);
end

function Lua_OpenServiceAthleticsRankItem:onHeadClick()
	if tonumber(self.data.player_show.id) == DataCenter.roleData.roleId then
		OperateAlert.showLangValue(400006);
	else
		Lua_WindowUtil.openWin("Lua_PlayerInfoWindow", Lua_WinParam.ACTION_OPEN, tonumber(self.data.player_show.id));
	end
end

function Lua_OpenServiceAthleticsRankItem:getWidth()
    return 694;
end

function Lua_OpenServiceAthleticsRankItem:getHeight()
	return 121;
end

function Lua_OpenServiceAthleticsRankItem:dispose()
	if self.headItem ~= nil then
		self.headItem:dispose();
		self.headItem = nil;
	end
	self:superCall("dispose");
end





















Lua_OpenAthleticsButtonItem = class("Lua_OpenAthleticsButtonItem", Lua_ButtonCell)
function Lua_OpenAthleticsButtonItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_OpenAthleticsButtonItem:buildShowItem()
	self:superCall("buildShowItem")
	self.bg_spr = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0)
	self.bg_spr.clickScale = false;
	self.bg_spr:addClickFuntion(self, self.onPressClick)

	self.name_txt = UICreate.createLabel(self.content, nil, 0, 0, 200, 40, 32);
    self.name_txt.pivot = UIUtils.Pivot.Center;
    self.name_txt.fontName = Lua_MyUISettings.huakangFontName;
    self.name_txt.alignmentValue = 4;
end

function Lua_OpenAthleticsButtonItem:dispose()
	self.data = nil;
	self.bg_spr = nil;
	self.name_txt = nil;
	self:superCall("dispose")
end

function Lua_OpenAthleticsButtonItem:setData(data)
    self.data = data;
end

function Lua_OpenAthleticsButtonItem:setSelected(index)
	if index == self.index then
		self.bg_spr:SetDimensions(188,67);
		self.bg_spr:setScale(0.9,0.9,0.9);
		self:setSiblingIndex(1);
		self.bg_spr:setAltas("common_altas_1", "xui_common_button_004_n");
		self.name_txt.text = Lua_ColorDefine.getColorStr("8f5123",self.data.textStr);
	else
		self:setSiblingIndex(0);
		self.bg_spr:SetDimensions(172,61);
		self.bg_spr:setScale(1,1,1);
		self.bg_spr:setAltas("common_altas_4", "xui_kfjj_widget_4");
		self.name_txt.text = Lua_ColorDefine.getColorStr("eee8ea",self.data.textStr);
	end
end