-- 专属订阅
Lua_PersonReadPanel = class("Lua_PersonReadPanel", Lua_DisplayObject);
function Lua_PersonReadPanel:ctor(p)
	self:superCall("ctor", p, "PersonReadPanel_skin");
end

function Lua_PersonReadPanel:buildShowItem()
	self:superCall("buildShowItem");

	local config = DataCenter.personReadData.personReadConfig;
	local itemInfo = getConfig("item", config.item_id);
	self.decSp_2:setAltas(itemInfo.atlas, itemInfo.sprite);

	-- 策划要求不显示每日奖励
	self.rewardIcon:setEnable(false);

	local config = DataCenter.personReadData.personReadConfig;
	self.desArr = Array();
	for i = 1, #config.content_list do
		self.desArr:add({
			idx = i,
			desId = config.content_list[i][1],
			desStr = config.content_list[i][2],
			isPercent = config.content_list[i][3]
		});
	end
	self.desList = Lua_DragList.new(self.uitweenObj_1, 571, 475, Lua_AxisDefine.Vertical, true);
	self.desList.canDrag = self.desArr:getSize() * 49 > 475;
	self.desList:setListCell(Lua_PersonReadItem, 571, 49, 1);
	self.desList:setSiblingIndex(1);
	self.desList:setLocation(13, -13, 0);
	self.desList:setArrayData(self.desArr);

	local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(config.recharge_id);
	self.rechargeTxt.text = LanUtil.formateStr(490000, tonumber(rechargeInfo.money));

	self.rewardIcon:addClickFuntion(self, self.onRewardIconClick);
	self.decSp_1:addClickFuntion(self, self.onClickShowDecSp_1);
	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
	self.uitweenImg_1:setLocation(-960, 0, 0);
	self.uitweenImg_2:setLocation(155, 740, 0);
	self.uitweenImg_1:setEnable(false);
	self.uitweenImg_2:setEnable(false);
	self.uitweenImg_1:addLoadCompleteFun(self, self.onLoadCompletedFun_1);
	self.uitweenImg_2:addLoadCompleteFun(self, self.onLoadCompletedFun_2);
	self.uitweenImg_1:setUrl("/images/activities/xui_zsdy_bg_3.png");
	self.uitweenImg_2:setUrl("/images/activities/xui_zsdy_title_1.png");

	self:addLuaEvent("UPDATE_PERSONREAD_INFO", self, self.updatePersonReadInfo);
	Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sPersonReadInfo();
end

function Lua_PersonReadPanel:setData(data)
end

function Lua_PersonReadPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);
end

function Lua_PersonReadPanel:updatePersonReadInfo()
	local reward_status = DataCenter.personReadData.reward_status;
	if reward_status ~= 2 then
		self.rewardIcon:setAltas("activities_atlas_1", "xui_zsdy_button_1_s");
	else
		self.rewardIcon:setAltas("activities_atlas_1", "xui_zsdy_button_1");
	end
	-- self:showRedDot(reward_status == 1);

	local end_times = DataCenter.personReadData.personReadEndTimes;
	-- print("50197031", end_times);
	self.rechargeBtn:setEnable(end_times <= 0);
	self.leftTimeTxt:setEnable(end_times > 0);
	if end_times > 0 then
		self:startTimer();
		self:updateLeftTime();
		self.rechargeTxt:setLangValue(490001);
	end
end

function Lua_PersonReadPanel:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.content);
			self.redPoint:createRedPointEff();
			self.redPoint:setRectAnchor(1);
			self.redPoint:setLocation(307, -87, 0);
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_PersonReadPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_PersonReadPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_PersonReadPanel:updateLeftTime()
	local time = DataCenter.personReadData.personReadEndTimes - DataCenter.roleData.serverTime;
	self.leftTimeTxt.text = LanUtil.formateStr(490002, Lua_TimeTransform.transSeconds18(time, true, true, true, false));
	if time <= 0 then
		self.leftTimeTxt:setEnable(false);
		self:endTimer();
		if self.isCheck then
			Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sPersonReadInfo();
		end
	end
	self.isCheck = time > 0;
end

function Lua_PersonReadPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
		
		local config = DataCenter.personReadData.personReadConfig;
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(config.recharge_id);
		self.rechargeTxt.text = LanUtil.formateStr(490000, tonumber(rechargeInfo.money));
	end
end

function Lua_PersonReadPanel:onRewardIconClick(go)
	if DataCenter.personReadData.reward_status == 1 then
		Lua_ProxyManager.getProxy("Lua_RaccoonMartProxy"):sDrawPersonReadReward();
	else
		Lua_WindowUtil.openWin("Lua_ShowPersonReadRewardWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_PersonReadPanel:onRechargeClick(go)
	DataCenter.personReadData.isPersonReadAct = true;
	if DataCenter.personReadData.personReadEndTimes <= 0 then
		local config = DataCenter.personReadData.personReadConfig;
		local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(config.recharge_id);
		DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
				tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
	end
end

function Lua_PersonReadPanel:onClickShowDecSp_1(go)
	local config = DataCenter.personReadData.personReadConfig;
	DataCenter.packUtil:showItemInfo(Lua_ToolVo.createToolVo(config.item_id, 1));
end

function Lua_PersonReadPanel:onLoadCompletedFun_1(go)
	self.uitweenImg_1:setEnable(true);
	TweenUtil.getInstance():addTweenTargetPos(self.uitweenImg_1.mainContent, 0.5, 0, -360, 0, 0);
end

function Lua_PersonReadPanel:onLoadCompletedFun_2(go)
	self.uitweenImg_2:setEnable(true);
	TweenUtil.getInstance():addTweenTargetPos(self.uitweenImg_2.mainContent, 0.5, 0, 155, 543, 0);
end

function Lua_PersonReadPanel:dispose()
	if self.desList ~= nil then
		self.desList:dispose();
		self.desList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_PersonReadItem = class("Lua_PersonReadItem", Lua_ListCell);
function Lua_PersonReadItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PersonReadItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, "", -285.5, 0, 0, 24, 24);
	self.desTxt.horizontalOverflowValue = 1;
	self.desTxt.verticalOverflowValue = 1;
	self.desTxt.colorStr = Lua_ColorDefine.transColor("543A2F");
end

function Lua_PersonReadItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local height = 0;
	local upStr = "";
	local param = {};
	local showValue = getConfig("exclusive_subscribe", "const", data.desId);
	if data.isPercent == 0 then
		upStr = showValue > 0 and showValue or (showValue * 100) .. "%";
	elseif data.isPercent == 1 then
		for i = 1, #data.desId do
			showValue = getConfig("exclusive_subscribe", "const", data.desId[i]);
			param[i] = showValue > 0 and showValue or (showValue * 100) .. "%";
		end
	elseif data.isPercent == 2 then
		local tvo;
		local str;
		for i = 1, #showValue do
			tvo = Lua_ToolVo.createToolVo(showValue[i][1]);
			str = spliceIconStr(tvo.iconAtlas, tvo.iconSprite, tvo.iconWidth, tvo.iconHeight);
			if height < tvo.iconHeight then
				height = tvo.iconHeight;
			end
			upStr = upStr .. "<url=itemClick_" .. showValue[i][1] .. ">" .. str .. showValue[i][2] .. "</url>";
		end
	end

	local des;
	if #param == 0 then
		des = LanUtil.formateStr(data.desStr, upStr);
	else
		des = LanUtil.formateStr(data.desStr, param[1], param[2], param[3], param[4], param[5]);
	end
	self.desTxt.text = LanUtil.formateStr(490003, data.idx, des);
	self.desTxt:setLocation(-285.5, height / 2, 0);
end

function Lua_PersonReadItem:onPressClick()
	local urlStr = self.desTxt:getUrlByMousePos();
	-- print(urlStr);
	if urlStr ~= nil then
		local arr = string.split(urlStr, "_");
		if arr and arr:getSize() > 1 then
			DataCenter.packUtil:showItemInfo(tonumber(arr[2]));
		end
	end
end

function Lua_PersonReadItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end