-- 升星专属（开服）
Lua_UpStarOfServerPanel = class("Lua_UpStarOfServerPanel", Lua_DisplayObject);
function Lua_UpStarOfServerPanel:ctor(p)
	self:superCall("ctor", p, "UpStarOfServerPanel_skin");
end

function Lua_UpStarOfServerPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + self.adaptHeight);

	self.freeTxt:setLangValue(203100);
	self.rechargeTxt:setLangValue(203101);

	self.selectHeroIcon = Lua_ItemIcon.new(self.content);
	self.selectHeroIcon:setLocation(-220, -200);
	self.selectHeroIcon:setScale(1.3, 1.3);
	self.selectHeroIcon:setSiblingIndex(5);
	self.selectHeroIcon:setRectAnchor(1);
	self.selectHeroIcon:setEnable(false);

	self.giftList = Lua_DragList.new(self.content, 680, 822 + self.adaptHeight, Lua_AxisDefine.Vertical);
	self.giftList:setListCell(Lua_UpStarOfServerRewardItem, 680, 130, 1);
	self.giftList:setLocation(0, -155, 0);

	self.introduceBtn:addClickFuntion(self, self.onTipsBtnClick);
	self.selectIcon:addClickFuntion(self, self.onSelectHeroClick);
	self.sureBtn:addClickFuntion(self, self.onSureClick);

    self:addLuaEvent("UPDATE_UPSTAROFSERVER_INFO", self, self.updateUpStarOfServerData);
    Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sUpStarOfServerInfo();
end

function Lua_UpStarOfServerPanel:setData(data)
end

function Lua_UpStarOfServerPanel:onScreenResize(adaptHeight)
	self:superCall("onScreenResize", adaptHeight);

	self.rewardBg:SetDimensions(MainWinDefine.DEFAULT_WIDTH, 1280 + adaptHeight);
	self.giftList:setContentRect(680, 822 + adaptHeight);
end

function Lua_UpStarOfServerPanel:onTipsBtnClick(go)
    local tipData = { des = LanUtil.getValue(203102), posX = 200, posY = 620 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_UpStarOfServerPanel:onSelectHeroClick(go)
	if DataCenter.upStarOfServerData.heroState ~= 2 then
		local showHeroArr = DataCenter.upStarOfServerUtil:getHeroListArr(nil);
		if showHeroArr:getSize() == 0 then
			OperateAlert.show(LanUtil.formateStr(203117, DataCenter.upStarOfServerUtil.constConfig.star_limit));
			return;
		end
		Lua_WindowUtil.openWin("Lua_UpStarOfServerSelectHeroWindow", Lua_WinParam.ACTION_OPEN);
	else
		OperateAlert.showLangValue(203103);
	end
end

function Lua_UpStarOfServerPanel:onSureClick(go)
	if DataCenter.upStarOfServerData.heroState ~= 2 then
		if DataCenter.upStarOfServerData.heroState == 1 then
			local tipData = {
				titleAtlas = "friend_altas",
				titleSprite = "ui_hy_title_02",
				des = LanUtil.getValue(203104),
				btnType = 1,
				owner = self,
				sureFun = self.onSureLockClick
			};
			Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
		else
			local showHeroArr = DataCenter.upStarOfServerUtil:getHeroListArr(nil);
			-- if showHeroArr:getSize() == 0 then
			-- 	OperateAlert.show(LanUtil.formateStr(203117, DataCenter.upStarOfServerUtil.constConfig.star_limit));
			-- 	return;
			-- end
			if showHeroArr:getSize() == 0 then
				OperateAlert.show(LanUtil.formateStr(203117, DataCenter.upStarOfServerUtil.constConfig.star_limit));
			else
				OperateAlert.showLangValue(203105);
			end
		end
	else
		OperateAlert.showLangValue(203103);
	end
end

function Lua_UpStarOfServerPanel:onSureLockClick(go)
	local curSelectHero = DataCenter.upStarOfServerData.curSelectHero;
	Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sUpStarOfServerAddHero(curSelectHero.id, 2, curSelectHero.star);
end

function Lua_UpStarOfServerPanel:updateUpStarOfServerData()
	local upStarOfServerData = DataCenter.upStarOfServerData;
	self.reSelectIcon:setEnable(upStarOfServerData.heroState == 1);

	local curSelectHero = upStarOfServerData.curSelectHero;
	if curSelectHero ~= nil then
		self.selectHeroIcon:setEnable(true);
		self.selectHeroIcon:setData(curSelectHero);
	end

	local rewardInfoArr = DataCenter.upStarOfServerUtil.rewardInfoArr;
	self.giftList:setArrayData(rewardInfoArr);

	if upStarOfServerData.heroState ~= 2 then
		self.sureBtn:setLangValue(203106);
		self.sureBtn:setStyle(1);
	else
		self.sureBtn:setLangValue(203107);
		self.sureBtn:setStyle(3);
	end

	self:startTimer();
	self:updateLeftTime();
end

function Lua_UpStarOfServerPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_UpStarOfServerPanel", 1, self, self.updateLeftTime);
	end
end

function Lua_UpStarOfServerPanel:updateLeftTime()
	local remainTime = DataCenter.upStarOfServerData.endTimes - DataCenter.roleData.serverTime;
	if remainTime <= 0 then
		self.leftTimesTxt.text = "00时00分00秒";
		self:endTimer();
		return;
	end
	self.leftTimesTxt.text = Lua_TimeTransform.transSeconds18(remainTime, true, true, true, false);
end

function Lua_UpStarOfServerPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updateLeftTime);
	end
end

function Lua_UpStarOfServerPanel:dispose()
	if self.selectHeroIcon ~= nil then
		self.selectHeroIcon:dispose();
		self.selectHeroIcon = nil;
	end
	if self.giftList ~= nil then
		self.giftList:dispose();
		self.giftList = nil;
	end
	self:endTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_UpStarOfServerRewardItem = class("Lua_UpStarOfServerRewardItem", Lua_ListCell);
function Lua_UpStarOfServerRewardItem:ctor(p)
	self:superCall("ctor", p, "UpStarOfServerRewardItem_skin");
end

function Lua_UpStarOfServerRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.freeIcon = Lua_ItemIcon.new(self.content);
	self.freeIcon:setLocation(-140, 0);
	self.freeIcon:setSiblingIndex(4);

	self.rewardList = Lua_DragList.new(self.content, 240, 115, Lua_AxisDefine.Horizontal);
	self.rewardList:setListCell(Lua_ServerRechargeRewardItem, 112, 112, 1);
	self.rewardList:setLocation(55, -2, 0);
	self:setSubList(self.rewardList);

	self.rechargeBtn:addClickFuntion(self, self.onRechargeClick);
end

function Lua_UpStarOfServerRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.condTipsTxt.text = LanUtil.formateStr(203108, data[1].star);
	self.rechargeBtn.label = LanUtil.formateStr(203109, data[2].recharge);

	local upStarOfServerData = DataCenter.upStarOfServerData;
	local curSelectHero = upStarOfServerData.curSelectHero;
	if curSelectHero == nil then
		self.condIcon:setGray(true);
		self.limitCountTxt:setEnable(false);
	else
		self.condIcon:setGray(upStarOfServerData.heroState ~= 2 or curSelectHero.star < data[1].star);
		self.limitCountTxt:setEnable(upStarOfServerData.heroState == 2 and curSelectHero.star >= data[1].star);
	end

	local freeRewardVo;
	if data[1].reward_item[1][1] <= 2 then
		if curSelectHero ~= nil then -- 0 本体，1 本体碎片，2 阵营礼包
			if data[1].reward_item[1][1] == 0 then
				freeRewardVo = Lua_ToolVo.createToolVo(curSelectHero.itemId);
			elseif data[1].reward_item[1][1] == 1 then
				freeRewardVo = Lua_ToolVo.createToolVo(curSelectHero.chipId);
			elseif data[1].reward_item[1][1] == 2 then 
				local constConfig = DataCenter.upStarOfServerUtil.constConfig;
				local freeRewardInfo = constConfig.camp_gift_list[curSelectHero.campType];
				freeRewardVo = Lua_ToolVo.createToolVo(freeRewardInfo[2]);
			end
		end
		self.freeIcon:setData(freeRewardVo);
	else
		freeRewardVo = Lua_ToolVo.createToolVo(data[1].reward_item[1][1]);
		self.freeIcon:setData(freeRewardVo);
	end

	if freeRewardVo ~= nil then
		local count = tonumber(data[1].reward_item[1][2]);
		local txtStr = count ~= 1 and count or nil; 
		self.freeIcon:showText(4, txtStr);
	end

	self.freeIcon:showEffect(false);
	if upStarOfServerData.heroState ~= 2 then
		self.rechargeBtn:setStyle(3);
	else
		self.rechargeBtn:setStyle(curSelectHero.star < data[1].star and 3 or 1);
		self.freeIcon:showEffect(upStarOfServerData.heroState == 2);
	end
	self.noSelectIcon:setEnable(data[1].reward_item[1][1] <= 2 and upStarOfServerData.heroState == 0);
end

function Lua_UpStarOfServerRewardItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx);

	local buyTimes = DataCenter.upStarOfServerData.giftState[idx];
	self.limitCountTxt.text = LanUtil.formateStr(203110, buyTimes.recharge_times, self.data[2].limit_times);

	self.freeTimes = buyTimes.free_times;
	self.receiveIcon:setEnable(buyTimes.free_times <= 0);
	self.rechargeBtn:setEnable(buyTimes.recharge_times > 0);
	self.sellOutIcon:setEnable(buyTimes.recharge_times <= 0);

	local rewardInfo = self.data[2].reward_item;
	for i = 1, #rewardInfo do
		rewardInfo[i][3] = idx;
	end
	self.rewardList:setArrayData(rewardInfo);
	self.rewardList.canDrag = #rewardInfo >= 3;
end

function Lua_UpStarOfServerRewardItem:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	if self.freeIcon:checkInBound(winPos.x, winPos.y) then
		self:onBtnClick();
	end
end

function Lua_UpStarOfServerRewardItem:onBtnClick()
	if self.freeTimes > 0 then
		if DataCenter.upStarOfServerData.heroState == 2 then
			local curSelectHero = DataCenter.upStarOfServerData.curSelectHero;
			if curSelectHero.star >= self.data[1].star then
				Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sReceiveUpStarOfServerGift(self.data[1].id);
			else
				OperateAlert.showLangValue(203116);
			end
			return;
		end

		if self.freeIcon.data ~= nil then
			DataCenter.packUtil:showItemInfo(self.freeIcon.data);
		else
			if DataCenter.upStarOfServerData.heroState == 0 then
				OperateAlert.showLangValue(203111);
			elseif DataCenter.upStarOfServerData.heroState == 1 then
				OperateAlert.showLangValue(203112);
			end
		end
	else
		DataCenter.packUtil:showItemInfo(self.freeIcon.data);
	end
end

function Lua_UpStarOfServerRewardItem:onRechargeClick(go)
	if DataCenter.upStarOfServerData.heroState ~= 2 then
		OperateAlert.showLangValue(203113);
	else
		local curSelectHero = DataCenter.upStarOfServerData.curSelectHero;
		if curSelectHero.star < self.data[1].star then
			OperateAlert.showLangValue(203114);
		else
			local rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(self.data[2].id);
			DataCenter.sdkInterface:PointOut(1, tonumber(rechargeInfo.money), tonumber(rechargeInfo.money_type),
					tonumber(rechargeInfo.id), rechargeInfo.gift_name, rechargeInfo.gold);
		end
	end
end

function Lua_UpStarOfServerRewardItem:dispose()
	if self.freeIcon ~= nil then
		self.freeIcon:dispose();
		self.freeIcon = nil;
	end
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ServerRechargeRewardItem = class("Lua_ServerRechargeRewardItem", Lua_ListCell);
function Lua_ServerRechargeRewardItem:ctor(p)
	self:superCall("ctor", p, "RechargeRewardItem_skin");
end

function Lua_ServerRechargeRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.rechargeIcon = Lua_ItemIcon.new(self.content);
	self.rechargeIcon:setLocation(0, 0);
	self.rechargeIcon:setSiblingIndex(0);
end

function Lua_ServerRechargeRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	-- local upStarOfServerData = DataCenter.upStarOfServerData;
	-- local curSelectHero = upStarOfServerData.curSelectHero;

	local rechargeRewardVo;
	local upStarOfServerData = DataCenter.upStarOfServerData;
	local curSelectHero = upStarOfServerData.curSelectHero;
	if data[1] <= 2 then
		if curSelectHero ~= nil then
			if data[1] == 0 then -- 0 本体，1 本体碎片，2 阵营礼包
				rechargeRewardVo = Lua_ToolVo.createToolVo(curSelectHero.itemId);
			elseif data[1] == 1 then
				rechargeRewardVo = Lua_ToolVo.createToolVo(curSelectHero.chipId);
			elseif data[1] == 2 then 
				local constConfig = DataCenter.upStarOfServerUtil.constConfig;
				local rechargeRewardInfo = constConfig.camp_gift_list[curSelectHero.campType];
				rechargeRewardVo = Lua_ToolVo.createToolVo(rechargeRewardInfo[2]);
			end
		end
		self.rechargeIcon:setData(rechargeRewardVo);
	else
		rechargeRewardVo = Lua_ToolVo.createToolVo(data[1]);
		self.rechargeIcon:setData(rechargeRewardVo);
	end

	if rechargeRewardVo ~= nil then
		local count = tonumber(data[2]);
		local txtStr = count ~= 1 and count or nil; 
		self.rechargeIcon:showText(4, txtStr);
	end

	self.noSelectIcon:setEnable(data[1] <= 2 and upStarOfServerData.heroState == 0);
	local buyTimes = DataCenter.upStarOfServerData.giftState[data[3]];
	self.receiveIcon:setEnable(buyTimes.recharge_times <= 0);
end

function Lua_ServerRechargeRewardItem:onPressClick(go)
	if self.rechargeIcon.data ~= nil then
		DataCenter.packUtil:showItemInfo(self.rechargeIcon.data);
	else
		OperateAlert.showLangValue(203111);
	end
end

function Lua_ServerRechargeRewardItem:dispose()
	if self.rechargeIcon ~= nil then
		self.rechargeIcon:dispose();
		self.rechargeIcon = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end