Lua_UpStarOfServerSelectHeroWindow = class("Lua_UpStarOfServerSelectHeroWindow", Lua_Window);
function Lua_UpStarOfServerSelectHeroWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_UpStarOfServerSelectHeroWindow";
	self.skinName = "UpStarOfServerSelectHeroWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showClose = true;
end

function Lua_UpStarOfServerSelectHeroWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.btnClose:setLocation(300, 355);

	self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setLocation(-32, -225, 0);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.updateHeroSiftInfo);
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);

	self.heroList = Lua_DragList.new(self.content, 600, 440, Lua_AxisDefine.Vertical);
	self.heroList:setListCell(Lua_selectHeroItem, 112, 150, 5);
	self.heroList:setLocation(0, 70, 0);
	self.heroList:setCellSpacing(10, 0);

	self.sureBtn:addClickFuntion(self, self.onSureClick);
end

function Lua_UpStarOfServerSelectHeroWindow:updateHeroSiftInfo(curCampType)
	if self.preCampType == curCampType then
		return;
	end
	self.preCampType = curCampType;
	self:selectHeroByCampType(curCampType);
end

function Lua_UpStarOfServerSelectHeroWindow:selectHeroByCampType(campType)
	if campType == Lua_HeroUtil.All_TYPE then
		campType = nil;
	end
	local showHeroArr = DataCenter.upStarOfServerUtil:getHeroListArr(campType);
	showHeroArr:sort("heroForce", true);
	
	self.heroList:setArrayData(showHeroArr);
	self.heroList:moveToIndex(1, true);
	local curSelectHero = DataCenter.upStarOfServerData.curSelectHero;
	if curSelectHero ~= nil then
		for i = 1, showHeroArr:getSize() do
			if showHeroArr[i] == curSelectHero then
				self.heroList:moveToIndex(i, true);
				self.heroList:setSelected(i);
				break;
			end
		end
	end

	self.noHeroObj:SetActive(showHeroArr:getSize() <= 0);
end

function Lua_UpStarOfServerSelectHeroWindow:onSureClick(go)
	local curSelectHero = DataCenter.upStarOfServerData.curSelectHero;
	if curSelectHero == nil then
		OperateAlert.showLangValue(203105);
	else
		self:hide();
		Lua_ProxyManager.getProxy("Lua_ExcellentActivityProxy"):sUpStarOfServerAddHero(curSelectHero.id, 1, curSelectHero.star);
	end
end

function Lua_UpStarOfServerSelectHeroWindow:dispose()
	if self.campSiftPanel ~= nil then
		self.campSiftPanel:dispose();
		self.campSiftPanel = nil;
	end

	if self.heroList ~= nil then
		self.heroList:dispose();
		self.heroList = nil;
	end
	DataCenter.upStarOfServerData.curSelectHero = DataCenter.upStarOfServerData:getCurSelectHero(DataCenter.upStarOfServerData.heroId);

	self:superCall("dispose");
end






--------------------------------------------------





Lua_selectHeroItem = class("Lua_selectHeroItem", Lua_ListCell);
function Lua_selectHeroItem:ctor(p)
	self:superCall("ctor", p, "SelectHeroItem_skin");
end

function Lua_selectHeroItem:buildShowItem()
	self:superCall("buildShowItem");

	self.heroIcon = Lua_ItemIcon.new(self.content);
end

function Lua_selectHeroItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.heroIcon:setData(data);
	self.heroNameTxt.text = data.name;
end

function Lua_selectHeroItem:onPressClick()
	DataCenter.upStarOfServerData.curSelectHero = self.data;
	return true;
end

function Lua_selectHeroItem:onSelectionChange(bSelect)
	self:superCall("onSelectionChange", bSelect);

	if bSelect then
		if self.selectIocn == nil then
			self.selectIocn = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_window_014", -1.4, 0.4, 112, 112);
		end
		self.selectIocn:setEnable(true);
	else
		if self.selectIocn ~= nil then
			self.selectIocn:setEnable(false);
		end
	end
end

function Lua_selectHeroItem:dispose()
	if self.heroIcon ~= nil then
		self.heroIcon:dispose();
		self.heroIcon = nil;
	end
	if self.selectIocn ~= nil then
		self.selectIocn:dispose();
		self.selectIocn = nil;
	end
	self.data = nil;

	self:superCall("dispose");
end