-- 边境远征战令
checkRequire("Lua_WarOrderBasePanel");
Lua_ExpeditionWarOrderPanel = class("Lua_ExpeditionWarOrderPanel", Lua_WarOrderBasePanel);
function Lua_ExpeditionWarOrderPanel:ctor(p)
	self:superCall("ctor", p, "ExpeditionWarOrderPanel_skin");
end

function Lua_ExpeditionWarOrderPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.markProgressBar:setValue(0);
	self.btnList:setEnable(false);
	self.tipTxt:setLangValue(560000);

	self.ruleBtn:addClickFuntion(self, self.onTipIconClick);
	self.addBtn:addClickFuntion(self, self.onAddBtnClick);
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
	self.unLockBtn:addClickFuntion(self, self.onUnLockBtnClick);
end

function Lua_ExpeditionWarOrderPanel:updateShow()
	self:superCall("updateShow");

	local rewardVoArr = DataCenter.warOrderData.rewardVoList[self.step];
	self.lvTxt.text = DataCenter.warOrderData.nextShowIdx - 1;

	self.lockState = DataCenter.warOrderData:curAdvActState(self.step) == false; -- 未解锁
	if self.lockState then
		local rechargeId = DataCenter.warOrderUtil:getRechargeId(self.data.param, self.step);
		self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		self.unLockBtn.label = LanUtil.formateStr(560001, self.rechargeInfo.money);
	else
		self.unLockBtn:setLangValue(560002);
	end
	self.lockIcon:setEnable(self.lockState);

	-- 经验条
	local maxValue = DataCenter.warOrderData:getNextProgressMaxValue(self.step);
	local curTarget = DataCenter.warOrderData.curTarget;
	self.markProgressBar:setMaxValue(maxValue);
	self.markProgressBar:setValue(curTarget);
	self.markProgressBar:setText(curTarget.."/"..maxValue);

	self:startTimer();
	self:onTimer();
end

function Lua_ExpeditionWarOrderPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		Lua_CommonUtil.addTimer("Lua_ExpeditionWarOrderPanel", 1, self, self.onTimer);
	end
end

function Lua_ExpeditionWarOrderPanel:onTimer()
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > 0 then
		self.timeTxt.text = LanUtil.formateStr(560007, Lua_TimeTransform.transSeconds18(time, true, true, true, false));            
	else
		self.timeTxt.text = "";
		self:endTimer();
	end
end

function Lua_ExpeditionWarOrderPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onTimer);
	end
end

function Lua_ExpeditionWarOrderPanel:onTipIconClick(go)
	local tipsData = { des = LanUtil.getValue(560003), posX = 200, posY = -230 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ExpeditionWarOrderPanel:onAddBtnClick(go)
	local info = DataCenter.warOrderUtil:getInfoByType(self.data.param);
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > info.can_buy_day * 86400 then
		OperateAlert.show(LanUtil.formateStr(560008, info.can_buy_day));
	else
		local maxValue = DataCenter.warOrderData:getNextProgressMaxValue(self.step);
		local curTarget = DataCenter.warOrderData.curTarget;
		if curTarget < maxValue then -- 可购买
			Lua_WindowUtil.openWin("Lua_WarOrderBuyExpWindow", Lua_WinParam.ACTION_OPEN, {
				curType = self.data.param,
				step = self.step,
				isLock = self.lockState
			});
		else
			OperateAlert.showLangValue(560009);
		end
	end
end

function Lua_ExpeditionWarOrderPanel:onUnLockBtnClick(go)
	if self.step == nil then
		return;
	end

	if self.lockState == false then
		OperateAlert.showLangValue(560004);
		return;
	end
	Lua_WindowUtil.openWin("Lua_WarOrderBuyWindow", Lua_WinParam.ACTION_OPEN, self.step);
end

function Lua_ExpeditionWarOrderPanel:dispose()
	self:endTimer();
	self:superCall("dispose");
end