-- 战令 巅峰对决panel
checkRequire("Lua_WarOrderBasePanel");
Lua_WarOrderPeakDuelPanel = class("Lua_WarOrderPeakDuelPanel", Lua_WarOrderBasePanel);
function Lua_WarOrderPeakDuelPanel:ctor(p)
	self:superCall("ctor", p, "WarOrderPeakDuelPanel_skin");
end

function Lua_WarOrderPeakDuelPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.btnList:setEnable(false);

	self.lvBg:addClickFuntion(self, self.onUnLockBtnClick);
	self.ruleBtn:addClickFuntion(self, self.onTipIconClick);
	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
	self.unLockBtn:addClickFuntion(self, self.onUnLockBtnClick);
end

function Lua_WarOrderPeakDuelPanel:updateShow()
	self:superCall("updateShow");

	local warOrderData = DataCenter.warOrderData;
	self.condTxt.text = LanUtil.formateStr(580000, warOrderData.curTarget);

	self.lockState = not warOrderData:curAdvActState(self.step); -- 未解锁
	if self.lockState then
		local rechargeId = DataCenter.warOrderUtil:getRechargeId(self.data.param, self.step);
		self.rechargeInfo = Lua_RechargeConfigData.getRechargeConfig(rechargeId);
		self.unLockBtn.label = LanUtil.formateStr(580001, self.rechargeInfo.money);
	else
		self.unLockBtn:setLangValue(580002);
	end
	self.lockIcon:setEnable(self.lockState);

	self:startTimer();
	self:onTimer();
end

function Lua_WarOrderPeakDuelPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		Lua_CommonUtil.addTimer("Lua_WarOrderPeakDuelPanel", 1, self, self.onTimer);
	end
end

function Lua_WarOrderPeakDuelPanel:onTimer()
	local time = DataCenter.warOrderData.warOrderEndTick - DataCenter.roleData.serverTime;
	if time > 0 then
		self.timeTxt:setEnable(true);
		self.timeTxt.text = LanUtil.formateStr(580007, Lua_TimeTransform.transSeconds18(time, true, true, true, false));            
	else
		self.timeTxt:setEnable(false);
		self:endTimer();
	end
end

function Lua_WarOrderPeakDuelPanel:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.onTimer);
	end
end

function Lua_WarOrderPeakDuelPanel:onTipIconClick(go)
	local tipsData = { des = LanUtil.getValue(580003), posX = 200, posY = -230 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_WarOrderPeakDuelPanel:onUnLockBtnClick(go)
	if self.step == nil then
		return;
	end

	if self.lockState == false then
		OperateAlert.showLangValue(580004);
		return;
	end
	Lua_WindowUtil.openWin("Lua_WarOrderBuyWindow", Lua_WinParam.ACTION_OPEN, self.step);
end

function Lua_WarOrderPeakDuelPanel:dispose()
	self:endTimer();
	self:superCall("dispose");
end